SystemOrganization addCategory: #'Glamour-Core'!

GLMAnnouncer subclass: #GLMLoggedObject
	instanceVariableNames: 'logger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMLoggedObject class
	instanceVariableNames: 'logger'!

GLMLoggedObject class
	instanceVariableNames: 'logger'!

GLMLoggedObject subclass: #GLMAction
	instanceVariableNames: 'action title shortcut position category icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMAction commentStamp: '<historical>' prior: 0!
Actions are elements of behavior that are executed upon a keyboard shortcut or other event.

Instances of Action are stored and maintained by Presentations. The exact representation is determined by the renderer, but actions can define a keyboard shortcut that should trigger the action or a title, category and position to be able to use the action as a context menu item.!

!GLMAction methodsFor: 'public interface' stamp: 'TudorGirba 12/16/2011 17:45'!
actOn: aPresentation 
	 
	^ self action 
		glamourValueWithArgs: 
			(Array 
				with: aPresentation 
				withAll: aPresentation entity asGlamorousArray)! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
action 
	"The code that should be executed when this action is triggered." 
	 
	^action! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
action: aBlock 
	"The code that should be executed when this action is triggered. 
 
	The block can take optional arguments, the first will always be the 
	presentation on which this action was triggered." 
	 
	action := aBlock! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
category 
	"The name of the category that should be used when this action is displayed in a context menu." 
	 
	^category! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
category: aString 
	"The name of the category that should be used when this action is displayed in a context menu." 
	 
	category := aString! !

!GLMAction methodsFor: 'testing' stamp: 'tg 9/28/2009 11:09'!
hasIcon
	 
	^self icon notNil! !

!GLMAction methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasShortcut 
	 
	^self shortcut notNil! !

!GLMAction methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasTitle 
	 
	^self title notNil! !

!GLMAction methodsFor: 'accessing' stamp: 'tg 9/28/2009 11:06'!
icon
	^ icon! !

!GLMAction methodsFor: 'accessing' stamp: 'tg 9/28/2009 11:06'!
icon: anObject
	icon := anObject! !

!GLMAction methodsFor: 'testing' stamp: 'EstebanLorenzano 4/20/2012 15:00'!
isButton
	^self hasIcon! !

!GLMAction methodsFor: 'testing' stamp: 'tg 9/17/2009 15:02'!
isCategorized
	 
	^self category notNil! !

!GLMAction methodsFor: 'testing' stamp: 'EstebanLorenzano 4/20/2012 15:00'!
isMenu
	^self hasTitle and: [ self hasIcon not]! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
position 
	"The relative position within a context menu." 
	 
	^position! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
position: anInteger 
	"The relative position within a context menu." 
	 
	position := anInteger! !

!GLMAction methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/20/2012 15:11'!
renderGlamorouslyOn: aRenderer
	^aRenderer renderAction: self! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
shortcut 
	"Shortcut character that this action should be triggered with when the focus rests on the corresponding presentation. 
	Modifiers are platform specific an can not be defined." 
	 
	^shortcut! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
shortcut: aCharacter 
	"Shortcut character that this action should be triggered with when the focus rests on the corresponding presentation. 
	Modifiers are platform specific an can not be defined." 
	 
	shortcut := aCharacter! !

!GLMAction methodsFor: 'accessing' stamp: 'TudorGirba 4/22/2012 22:37'!
shortcutAsString 
	"Answers a string explaining shortcut"
	^self shortcut 
		ifNotNil: [
			'alt+', 
				(self shortcut isUppercase 
					ifTrue: [ 'shift+' ]
					ifFalse: [ '' ]), 
				self shortcut asLowercase asString ]! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
title 
	"Title that this action should use in a context menu." 
	 
	^title! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
title: anObject 
	"Title that this action should use in a context menu." 
	 
	title := anObject! !

!GLMAction methodsFor: 'testing' stamp: 'tg 9/25/2010 17:52'!
worksWithMorphic
	^ false! !

!GLMAction methodsFor: 'testing' stamp: 'tg 9/25/2010 17:52'!
worksWithSeaside
	^ false! !

GLMAction subclass: #GLMGenericAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMGenericAction commentStamp: '<historical>' prior: 0!
This is an action that is supposed to work in any context (e.g., Morphic or Seaside)!

!GLMGenericAction methodsFor: 'testing' stamp: 'tg 9/25/2010 17:53'!
worksWithMorphic
	^ true! !

!GLMGenericAction methodsFor: 'testing' stamp: 'tg 9/25/2010 17:53'!
worksWithSeaside
	^ true! !

GLMGenericAction subclass: #GLMSpawnBrowserAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMLoggedObject classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:05'!
initialize 
	logger := GLMLogger instance! !

!GLMLoggedObject classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 16:47'!
logger
	^ logger! !

!GLMLoggedObject classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 16:48'!
logger: aLogger
	logger := aLogger! !

!GLMLoggedObject methodsFor: 'announce' stamp: 'tg 5/25/2010 23:53'!
announce: anAnnouncement
	self logger logAnnouncement: anAnnouncement from: self. 
	super announce: anAnnouncement! !

!GLMLoggedObject methodsFor: 'initialize-release' stamp: 'TudorGirba 5/18/2011 12:06'!
initialize 
	super initialize.
	logger := GLMLogger instance ! !

!GLMLoggedObject methodsFor: 'accessing' stamp: 'tg 5/24/2010 16:43'!
logger
	^ logger! !

!GLMLoggedObject methodsFor: 'accessing' stamp: 'tg 5/24/2010 16:43'!
logger: anObject
	logger := anObject! !

!GLMLoggedObject methodsFor: 'copying' stamp: 'TudorGirba 7/11/2011 11:20'!
postCopy 
	super postCopy.
	self resetAnnouncer! !

GLMLoggedObject subclass: #GLMNoBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMNoBrowser class
	instanceVariableNames: 'uniqueInstance'!

!GLMNoBrowser commentStamp: 'TudorGirba 2/4/2011 20:22' prior: 0!
A NoBrowser is a browser without behavior and that does not require a container pane. The root pane is always placed in a NoBrowser.
Given that it has no behavior, a NoBrowser is a singleton to avoid multiple unnecessary instances.!

GLMNoBrowser class
	instanceVariableNames: 'uniqueInstance'!

!GLMNoBrowser classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 08:30'!
initialize

	self initializeUniqueInstance! !

!GLMNoBrowser classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:17'!
initializeUniqueInstance

	uniqueInstance := self basicNew initialize! !

!GLMNoBrowser classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 08:29'!
new

	^self uniqueInstance! !

!GLMNoBrowser classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 08:30'!
uniqueInstance

	^uniqueInstance! !

!GLMNoBrowser methodsFor: 'accessing' stamp: 'TudorGirba 2/4/2011 20:23'!
innerPortEvent: aPortEvent 
	"Needed for simulating a browser"! !

GLMLoggedObject subclass: #GLMPane
	instanceVariableNames: 'browser name presentations ports lastActivePresentation allowedToNotePresentationsChanged cachedMatchingPresentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPane commentStamp: 'TudorGirba 2/15/2011 11:03' prior: 0!
A GLMPane represents the "physical" building block of a browser. A pane is presented using a composite presentation (held in the presentations instance var).

It announces:
- GLMMatchingPresentationsChanged
- GLMPresentationsChanged

Instance Variables
	browser:		Browser
	lastActivePresentation:		Presentation
	name:		Symbol
	ports:		Collection of Ports
	presentations:		CompositePresentation!

!GLMPane classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 09:09'!
in: aBrowser 
	
	^self new initializeIn: aBrowser! !

!GLMPane classSide methodsFor: 'instance creation' stamp: 'jorge.ressia 6/2/2009 23:42'!
named: aString 
	^self new initializeNamed: aString! !

!GLMPane classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/2/2009 20:28'!
named: aString in: aBrowser

	^self new initializeNamed: aString in: aBrowser 
! !

!GLMPane classSide methodsFor: 'private' stamp: ' 4/5/09 22:18'!
portClass 
	 
	^GLMPanePort! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 4/11/2010 23:28'!
addPresentation: aPresentation
	self addPresentations: (OrderedCollection with: aPresentation)! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 5/25/2010 14:40'!
addPresentationSilently: each
	^ presentations
		add:
			(each
				pane: self;
				yourself)! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 5/25/2010 14:40'!
addPresentations: aCollection
	self notingPresentationChangeDo: [ 
		aCollection do: [ :each | self addPresentationSilently: each ] ]! !

!GLMPane methodsFor: 'converting' stamp: ' 4/5/09 22:18'!
asGlamorousPane 
	 
	^self! !

!GLMPane methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser 
	 
	^browser! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 12/29/2009 23:19'!
browser: aBrowser
	browser := aBrowser! !

!GLMPane methodsFor: 'accessing' stamp: 'TudorGirba 12/5/2011 12:55'!
cachedMatchingPresentations
	^ cachedMatchingPresentations ifNil: [ cachedMatchingPresentations := self matchingPresentations ]! !

!GLMPane methodsFor: 'accessing' stamp: 'TudorGirba 12/5/2011 12:54'!
cachedMatchingPresentations: anObject
	^ cachedMatchingPresentations := anObject! !

!GLMPane methodsFor: 'accessing' stamp: 'TudorGirba 7/21/2011 13:43'!
clearIn: aContext 
	self notingPresentationChangeDo: [
		self presentations clear.
		self ports do: [:each | each value: nil in: aContext copy ]]! !

!GLMPane methodsFor: 'initialization' stamp: 'jorge.ressia 6/3/2009 09:10'!
defaultName

	^'undefined'! !

!GLMPane methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasBrowser 
	 
	^self browser isNil not! !

!GLMPane methodsFor: 'initialization' stamp: 'tg 5/25/2010 14:12'!
initialize
	super initialize.
	ports := OrderedCollection new.
	presentations := GLMCompositePresentation new pane: self; yourself! !

!GLMPane methodsFor: 'initialization' stamp: 'jorge.ressia 6/3/2009 09:10'!
initializeIn: aBrowser 
	
	self initializeNamed: self defaultName in: aBrowser! !

!GLMPane methodsFor: 'initialization' stamp: 'jorge.ressia 6/2/2009 23:43'!
initializeNamed: aString 
	self initializeNamed: aString in: GLMNoBrowser new  ! !

!GLMPane methodsFor: 'initialization' stamp: 'tg 1/11/2010 21:59'!
initializeNamed: aString in: aBrowser 
	self initialize.
	name := aString ifNil: [ self defaultName ].
	browser := aBrowser! !

!GLMPane methodsFor: 'private' stamp: 'tg 12/30/2009 18:50'!
isAllowedToNotePresentationsChanged
	^ allowedToNotePresentationsChanged ifNil: [allowedToNotePresentationsChanged := true ]! !

!GLMPane methodsFor: 'testing' stamp: 'TudorGirba 1/28/2011 00:13'!
isLastActivePresentation: aPresentation
	^ self lastActivePresentation notNil and: [ 
		aPresentation title = self lastActivePresentation title ]! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 10/18/2009 19:29'!
lastActivePresentation
	^ lastActivePresentation! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 10/18/2009 19:29'!
lastActivePresentation: anObject
	lastActivePresentation := anObject! !

!GLMPane methodsFor: 'accessing' stamp: 'TudorGirba 12/5/2011 12:54'!
matchingPresentations
	^ cachedMatchingPresentations := presentations matchingPresentations! !

!GLMPane methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
name 
	 
	^name! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 1/12/2010 07:30'!
name: aString
	name := aString! !

!GLMPane methodsFor: 'private' stamp: 'TudorGirba 12/5/2011 12:54'!
notingPresentationChangeDo: aBlock
	"Executes aBlock. If during the execution of the block one of my presentations change, I will emit announces. I also take care of not entering an infinite loop."
	| oldPresentations oldMatchingPresentations | 
	self isAllowedToNotePresentationsChanged ifFalse: [
		aBlock value.
		^ self].
	"this should create a context and then check for it before announcing.
	Like this we can deal with the problem of announcing the same announcement twice"
	allowedToNotePresentationsChanged := false.
	
	oldPresentations := presentations presentations copy. 
	oldMatchingPresentations := self cachedMatchingPresentations.
	aBlock value. 
	presentations presentations  ~= oldPresentations ifTrue: [
		self announce: ((GLMPresentationsChanged new) 
						pane: self; 
						oldPresentations: oldPresentations; 
						yourself)]. 
	self matchingPresentations ~= oldMatchingPresentations ifTrue: [
		self announce: ((GLMMatchingPresentationsChanged new) 
						pane: self; 
						oldMatchingPresentations: oldMatchingPresentations; 
						yourself)].
	allowedToNotePresentationsChanged := true.
! !

!GLMPane methodsFor: 'accessing' stamp: 'TudorGirba 2/4/2011 15:36'!
port: aSymbol
	"returns the port with the given name"
	^ ports detect: [ :each | each name = aSymbol ] ifNone: [
		ports addLast: (
			(self class portClass new) 
						pane: self; 
						name: aSymbol; 
						yourself) ]! !

!GLMPane methodsFor: 'private' stamp: 'cyrilledelaunay 3/30/2011 10:28'!
portEvent: aPortEvent

	"we unregister all presentations from announcements because they will get replaced anyway"
	aPortEvent portName = #entity ifTrue: [ self unregisterFromAllAnnouncements ].
	self browser innerPortEvent: aPortEvent.
	self presentations withAllDo: [ :each | each outerPortEvent: aPortEvent ]! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 1/12/2010 07:36'!
ports
	^ ports! !

!GLMPane methodsFor: 'copying' stamp: 'TudorGirba 7/11/2011 11:17'!
postCopy
	| newPort |
	super postCopy.
	self flag: 'self unregisterFromAllAnnouncements ?'.
	presentations := presentations copy.
	ports := ports collect: [:each | 
		newPort := each copy.
		newPort pane: self.
		self flag: 'what about value?'.
		newPort ]! !

!GLMPane methodsFor: 'accessing' stamp: 'tg 1/11/2010 18:06'!
presentations
	^ presentations! !

!GLMPane methodsFor: 'accessing' stamp: 'TudorGirba 5/18/2011 13:45'!
presentations: aCompositePresentation
	self notingPresentationChangeDo: [
		presentations pane: nil.
		presentations resetAnnouncer.
		aCompositePresentation withAllDo: [:each | each pane: self].
		presentations := aCompositePresentation ]! !

!GLMPane methodsFor: 'printing' stamp: 'DamienCassou 7/3/2011 19:56'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self identityHash printString;
		space;
		nextPutAll: self name;
		nextPut: $)! !

!GLMPane methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderPane: self! !

!GLMPane methodsFor: 'announcements' stamp: 'TudorGirba 7/10/2011 17:25'!
resetAnnouncer
	super resetAnnouncer.
	self presentations do: [ :each | each resetAnnouncer ]! !

!GLMPane methodsFor: 'updating' stamp: 'tg 1/31/2010 00:26'!
unregisterFromAllAnnouncements
	self presentations unregisterFromAllAnnouncements! !

!GLMPane methodsFor: 'updating' stamp: 'TudorGirba 12/5/2011 12:57'!
update 
	self notingPresentationChangeDo: [
		"nothing in particular. 
		just make sure that matching presentations are recomputed"].
	self presentations do: [ :each | each update ]! !

!GLMPane methodsFor: 'enumerating' stamp: 'TudorGirba 7/10/2011 01:19'!
withAllPanes
	| result |
	result := OrderedCollection new.
	self withAllPanesAndPresentationsDo: [:each |
		(each isKindOf: GLMPane) ifTrue: [ result add: each ]].
	^ result! !

!GLMPane methodsFor: 'enumerating' stamp: 'TudorGirba 7/9/2011 19:45'!
withAllPanesAndPresentationsDo: aBlock
	aBlock value: self.
	self presentations withAllPanesAndPresentationsDo: aBlock! !

!GLMPane methodsFor: 'enumerating' stamp: 'TudorGirba 7/9/2011 20:06'!
withAllPresentations
	| result |
	result := OrderedCollection new.
	self withAllPanesAndPresentationsDo: [:each |
		(each isKindOf: GLMPresentation) ifTrue: [ result add: each ]].
	^ result! !

GLMLoggedObject subclass: #GLMPort
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPort commentStamp: 'tg 12/19/2009 00:15' prior: 0!
GLMPort represents the abstract port. Any port has a name. Subclasses can provide further semantics to a port.!

GLMPort subclass: #GLMBoundPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBoundPort methodsFor: 'comparing' stamp: ' 4/5/09 22:18'!
= anObject 
	"Compare this port with another for equality. 
 
	This is used to compare ParentPorts with PanePorts where the earlier is a proxy for the latter." 
	 
	^((anObject isKindOf: GLMBoundPort) and: [self pane = anObject pane]) 
		and: [self name = anObject name]! !

!GLMBoundPort methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasPane 
	 
	^self pane notNil! !

!GLMBoundPort methodsFor: 'comparing' stamp: ' 4/5/09 22:18'!
hash 
	"Ports which are equal should return hash. 
 
	Since equality is used only for matching port proxies (ParentPort) with 
	their actual port, the hash function is overridden only in ParentPort." 
	 
	^super hash! !

!GLMBoundPort methodsFor: 'validation' stamp: 'simondenier 4/15/2010 15:55'!
notingPresentationChangeDo: aBlock
	self pane notingPresentationChangeDo: aBlock! !

!GLMBoundPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	 
	self subclassResponsibility! !

!GLMBoundPort methodsFor: 'validation' stamp: 'JorgeRessia 11/6/2009 13:09'!
validate: anObject 
	self pane presentations isEmpty ifTrue: [^true].
	^self pane presentations allSatisfy: [ :each | each validate: anObject on: self]! !

GLMBoundPort subclass: #GLMPanePort
	instanceVariableNames: 'pane value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPanePort commentStamp: '<historical>' prior: 0!
A port that belongs to a pane.

Bound ports have a few special characteristics in comparison to their superclass. For one, they don't just assign a value to themselves using #value: but rather generate a transmission that set the value so that the pane can handle the transmission and forward it to other ports if necessary, depending on the policy of the containing browser.!

!GLMPanePort methodsFor: 'accessing' stamp: 'jorge.ressia 5/30/2009 14:05'!
basicValue: anObject
	value := anObject. 
	! !

!GLMPanePort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 19:43'!
changeValueTo: anObject in: aTransmissionContext
	| oldValue | 
	oldValue := self value.
	self pane notingPresentationChangeDo: [
		self silentValue: anObject.  
		self pane portEvent: 
					(GLMPortEvent 
						on: self
						previouslyValued: oldValue
						in: aTransmissionContext) ]! !

!GLMPanePort methodsFor: 'copying' stamp: 'tg 12/30/2009 03:04'!
copyAccordingToPaneMapping: newPanesMapping inNewBrowser: anotherBrowser
	^ (newPanesMapping at: self pane) port: self name! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	 
	^pane! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane: aPane 
	 
	pane := aPane! !

!GLMPanePort methodsFor: 'accessing' stamp: 'jre 9/19/2009 08:16'!
printOn: aStream 
	 
	aStream 
		nextPutAll: 'Port (pane='; 
		nextPutAll: self pane name printString; 
		nextPutAll: ' name='; 
		nextPutAll: self name printString; 
		nextPutAll: ' value='; 
		nextPutAll: self value printString; 
		nextPut: $)! !

!GLMPanePort methodsFor: 'accessing' stamp: 'tg 12/17/2009 03:12'!
receive: aTransmission in: aContext
	self value: aTransmission value in: aContext! !

!GLMPanePort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 22:30'!
resetValue
	| context |
	context := GLMTransmissionContext new.
	context addPort: self.
	self changeValueTo: nil in: context.! !

!GLMPanePort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 19:43'!
silentValue: anObject
	value := anObject! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value 
	 
	^value! !

!GLMPanePort methodsFor: 'accessing' stamp: 'tg 2/17/2010 22:51'!
value: anObject in: aContext
	(self validate: anObject) ifFalse: [^ self].
	aContext addPort: self.
	self changeValueTo: anObject in: aContext.! !

GLMBoundPort subclass: #GLMPresentationBoundPort
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentationBoundPort commentStamp: 'TudorGirba 2/4/2011 20:27' prior: 0!
This is a fancy port that enables us to access the value of a port from outside of a browser. It is bound to a presentation in the sense that it asks the presentation dynamically for the pane. In this way, when a presentation is placed (or copied) in another pane, the value will be dynamically looked up.

Instance Variables:
	presentation	<GLMPresentation>!

!GLMPresentationBoundPort methodsFor: 'copying' stamp: 'tg 12/30/2009 03:06'!
copyAccordingToPaneMapping: newPanesMapping inNewBrowser: anotherBrowser
	^ self copy presentation: anotherBrowser! !

!GLMPresentationBoundPort methodsFor: 'comparing' stamp: ' 4/5/09 22:18'!
hash 
	 
	^self port hash! !

!GLMPresentationBoundPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	 
	^self presentation pane! !

!GLMPresentationBoundPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
port 
	 
	^self pane port: self name! !

!GLMPresentationBoundPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentation 
	 
	^presentation! !

!GLMPresentationBoundPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentation: aPresentation 
	 
	presentation := aPresentation! !

!GLMPresentationBoundPort methodsFor: 'accessing' stamp: 'tg 12/17/2009 03:14'!
receive: aTransmission in: aContext
	self port receive: aTransmission in: aContext
	
! !

!GLMPresentationBoundPort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 19:44'!
silentValue: anObject 
	self port silentValue: anObject    ! !

!GLMPresentationBoundPort methodsFor: 'accessing' stamp: 'TudorGirba 12/5/2011 14:33'!
value 
	self flag: 'checking for #entity is rather not elegant, but it is a solution to not affect the other custom ports that will probably be desired to be populated in other ways.'.
	^ self name == #entity 
		ifTrue: [ self presentation transformation glamourValue: self port value asGlamorousMultiValue ] 
		ifFalse: [ self port value ]! !

!GLMPresentationBoundPort methodsFor: 'accessing' stamp: 'tg 12/18/2009 23:57'!
value: anObject in: aContext
	(self validate: anObject) ifFalse: [^ self].
	self port value: anObject in: aContext! !

!GLMPort methodsFor: 'copying' stamp: 'tg 12/30/2009 03:05'!
copyAccordingToPaneMapping: newPanesMapping inNewBrowser: anotherBrowser
	^ self subclassResponsibility! !

!GLMPort methodsFor: 'testing' stamp: 'tg 1/5/2010 13:40'!
hasPane
	^ false! !

!GLMPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
name 
	 
	^name! !

!GLMPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
name: aSymbol 
	 
	name := aSymbol! !

!GLMPort methodsFor: 'validation' stamp: 'simondenier 4/15/2010 15:56'!
notingPresentationChangeDo: aBlock
	aBlock value! !

!GLMPort methodsFor: 'printing' stamp: 'tg 1/13/2010 16:31'!
printOn: aStream 
	super printOn: aStream.
	aStream 
		nextPut: Character space;
		nextPutAll: self identityHash printString;
		nextPutAll: ' (name='; 
		nextPutAll: self name printString; 
		nextPutAll: ' value='; 
		nextPutAll: self value printString; 
		nextPut: $)! !

!GLMPort methodsFor: 'accessing' stamp: 'tg 12/18/2009 23:53'!
receive: aTransmission 
	self receive: aTransmission in: GLMTransmissionContext new! !

!GLMPort methodsFor: 'accessing' stamp: 'tg 12/18/2009 23:53'!
receive: aTransmission in: aContext 
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 19:42'!
silentValue: anObject
	"This is meant to be used internally"
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 19:45'!
transientValue: anObject 
	| previousValue |
	previousValue := self value. 
	self value: anObject.
	self silentValue: previousValue! !

!GLMPort methodsFor: 'validation' stamp: 'JorgeRessia 11/6/2009 13:10'!
validate: anObject 

	^true! !

!GLMPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value 
	 
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: 'tg 2/17/2010 14:02'!
value: anObject 
	self value: anObject in: GLMTransmissionContext new! !

!GLMPort methodsFor: 'accessing' stamp: 'tg 12/18/2009 23:55'!
value: anObject in: aContext
	self subclassResponsibility! !

GLMPort subclass: #GLMSimplePort
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMSimplePort commentStamp: 'TudorGirba 2/4/2011 20:29' prior: 0!
GLMSimplePort simply offers a hardcoded value. It is typically used in tests, but it can be useful in special cases when we need to simulate a Port.

Instance Variables:
	value	<ProtoObject | PseudoContext>!

!GLMSimplePort methodsFor: 'accessing' stamp: 'tg 12/18/2009 23:57'!
receive: aTransmission in: aContext
	self value: aTransmission value in: aContext! !

!GLMSimplePort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 19:43'!
silentValue: anObject
	value := anObject! !

!GLMSimplePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value 
	 
	^value! !

!GLMSimplePort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 19:43'!
value: anObject in: aContext
	aContext addPort: self.
	self silentValue: anObject  ! !

GLMLoggedObject subclass: #GLMPortEvent
	instanceVariableNames: 'port oldValue transmissionContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPortEvent commentStamp: 'tg 12/19/2009 00:12' prior: 0!
A GLMPortEvent is passed to the parent pane every time a Port changes.

Instance Variables
	oldValue:		<Object>
	port:		Port
	transmission:		Transmission
	transmissionContext:	TransmissionContext!

!GLMPortEvent classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 5/30/2009 11:47'!
on: aPort previouslyValued: anObject 
	^ self new 
		initializeOn: aPort
		previouslyValued: anObject! !

!GLMPortEvent classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 5/30/2009 12:55'!
on: aPort previouslyValued: anObject in: aTransmissionContext 
	^self new initializeOn: aPort previouslyValued: anObject in: aTransmissionContext ! !

!GLMPortEvent methodsFor: 'testing' stamp: 'DamienCassou 7/3/2011 19:52'!
hasChanged
	"Answer whether the port value changed due to the event."

	^ self value ~~ self oldValue! !

!GLMPortEvent methodsFor: 'initialize-release' stamp: 'jorge.ressia 5/30/2009 13:01'!
initializeOn: aPort previouslyValued: anObject 
	self initializeOn: aPort previouslyValued: anObject in: OrderedCollection new! !

!GLMPortEvent methodsFor: 'initialize-release' stamp: 'jorge.ressia 5/30/2009 12:58'!
initializeOn: aPort previouslyValued: anObject in: aTransmissionContext 
	port := aPort.
	oldValue := anObject.
	transmissionContext := aTransmissionContext! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
oldValue 
	 
	^oldValue! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
pane 
	 
	^self port pane! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
port 
	 
	^port! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
portName 
	 
	^self port name! !

!GLMPortEvent methodsFor: 'printing' stamp: 'tg 2/17/2010 19:10'!
printOn: aStream
	super printOn: aStream.
	aStream 
		nextPutAll: '(port='.
	self port printOn: aStream.
	aStream nextPutAll: ' oldValue='; nextPutAll: self oldValue printString; nextPut: $)
		! !

!GLMPortEvent methodsFor: 'accessing' stamp: 'tg 12/18/2009 23:58'!
transmissionContext
	^ transmissionContext! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
value 
	 
	^self port value! !

GLMLoggedObject subclass: #GLMPresentation
	instanceVariableNames: 'pane title titleIcon transformation actions condition implicitNotNil dynamicActionsBlock color customValidation shouldValidate acceptsSelection parentPrototype registeredAnnouncers updateActions selectionActions selectionDynamicActionsBlock implicitAllNil rawSelectionTransmissions statusPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentation commentStamp: 'DamienCassou 7/19/2011 21:14' prior: 0!
A GLMPresentation is the abstract class for the hierarchy of presentations. A presentation specifies how the pane (held in the pane instance variable) is going to be displayed. It typically reads at least the #entity port of a pane and populates at least the #selection port.

updateActions holds a collection of GLMUpdateAction that are used to update the presentation via announcements.

rawSelectionTransmissions holds a collection of transmission whose origins are this presentation's #rawSelection port. Destinations of this transmissions are on the pane. This collection always contains at least one transmission to the pane's #selection port. To transform the values travelling through this transmission use #send:. To add new transmissions, use #send:as:.

Because Glamour has a prototype-based design it relies on copying the presentations before installing them in panes (via transmissions). The parentPrototype instance variable keeps track of the presentation from which the current one was copied.

It raises:
- GLMContextChanged to let the world know that something has changed in the containing pane. This is typically used by the renderer to update the rendering.
- GLMPresentationUpdated to let the world know that the presentations wants to be updated because of reasons other than the pane context changed.!

GLMPresentation subclass: #GLMBrowser
	instanceVariableNames: 'transmissions panes initialExtent watcherPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBrowser commentStamp: 'TudorGirba 2/4/2011 17:50' prior: 0!
The Browser is one of the core components in Glamour.

It contains panes and transmissions between their ports. These transformations can either be explicitely defined by the user (such as in the Tabulator) or implicitely defined (such as in the Finder).

Browsers serve as composition managers. They determine when and under which conditions transmissions should be triggered and how they connect the ports of panes. In return, panes inform the browsers when event occur on their ports so that the browser can make an informed decission on what to do.

A Browser is a Presentation which means that it can be nested into other browsers.!

!GLMBrowser classSide methodsFor: 'constants' stamp: 'tg 3/31/2010 19:23'!
defaultStatusbarPane
	^ #'_statusbar'! !

!GLMBrowser classSide methodsFor: 'scripting' stamp: 'tg 4/1/2010 07:01'!
withStatusbar
	^ self new addStatusbar! !

!GLMBrowser methodsFor: 'accessing' stamp: 'tg 3/31/2010 21:55'!
addPane: aPane
	aPane browser: self.
	self panes add: aPane.
	self hasStatusbar ifTrue: [
		self addDefaultStatusbarTransmissionFrom: aPane ].
	^ aPane! !

!GLMBrowser methodsFor: 'accessing' stamp: 'TudorGirba 4/22/2012 21:56'!
addTransmission: aTransmission 
	aTransmission browser: self.
	^ self transmissions addLast: aTransmission! !

!GLMBrowser methodsFor: 'events' stamp: 'AndreiChis 10/24/2012 13:48'!
close
	self announce: GLMBrowserClosed new! !

!GLMBrowser methodsFor: 'scripting' stamp: 'jorge.ressia 6/2/2009 17:11'!
context

	^OrderedCollection new! !

!GLMBrowser methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
custom: aPresentation 
	 
	self subclassResponsibility! !

!GLMBrowser methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
defaultRenderer 
	 
	^GLMRenderer subclasses first new! !

!GLMBrowser methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/30/2011 11:55'!
initialExtent

	^ initialExtent ifNil: [ initialExtent := RealEstateAgent standardWindowExtent]! !

!GLMBrowser methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/30/2011 11:56'!
initialExtent: aPoint

	initialExtent := aPoint! !

!GLMBrowser methodsFor: 'initialize-release' stamp: 'TudorGirba 5/20/2012 23:40'!
initialize
	super initialize.
	panes := OrderedCollection new.
	transmissions := OrderedCollection new.
	statusPane := nil.
	watcherPane := nil! !

!GLMBrowser methodsFor: 'scripting' stamp: 'tg 5/24/2009 19:15'!
initializeScriptingDefaults 
	"Initialize some default behavior if the user did not explcitly script it. 
 
	Subclasses can use this to create a default startup transmission or show 
	a default pane or something like that." 
	
	^self! !

!GLMBrowser methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
open 
	 
	^self openWith: self defaultRenderer! !

!GLMBrowser methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
openOn: anObject 
	 
	^self 
		openOn: anObject 
		with: self defaultRenderer! !

!GLMBrowser methodsFor: 'scripting' stamp: 'TudorGirba 7/15/2011 13:54'!
openOn: anObject with: aRenderer 
	 
	self startOn: anObject. 
	^ self openWith: aRenderer! !

!GLMBrowser methodsFor: 'scripting' stamp: 'TudorGirba 7/15/2011 13:54'!
openWith: aRenderer 
	 
	^ aRenderer open: self! !

!GLMBrowser methodsFor: 'events' stamp: 'TudorGirba 5/20/2012 22:21'!
outerPortEvent: aPortEvent  
	super outerPortEvent: aPortEvent.	
	aPortEvent hasChanged ifTrue: [
		(self transmissions select: [:each | 
			(each originatesAt: aPortEvent port) and: [
				( aPortEvent transmissionContext includesPort: each destination) not ]]) 
			do: [:each | each transmitIn: aPortEvent transmissionContext copy ]]! !

!GLMBrowser methodsFor: 'accessing' stamp: 'tg 3/31/2010 19:45'!
panes
	^ panes ifNil: [	panes := OrderedCollection new ]! !

!GLMBrowser methodsFor: 'copying' stamp: 'TudorGirba 5/21/2012 00:32'!
postCopy
	| newPane newPanes newPanesMapping newTransmission oldPane oldWatcherPane |
	super postCopy.
	"needed for setting the right panes for the new transmissions"
	newPanesMapping := Dictionary new. 
	newPanes := OrderedCollection new.
	self panes do: [:each | 
		newPane := each copy.
		newPane browser: self.
		newPanes addLast: newPane.
		newPanesMapping at: each put: newPane ].
	oldPane := self pane.
	oldWatcherPane := self watcherPane.
	watcherPane := nil.
	pane := nil.
	newPanesMapping at: oldPane ifAbsentPut: [ self pane ].
	newPanesMapping at: oldWatcherPane ifAbsentPut: [ self watcherPane ].
	self flag: 'we should also copy the values of ports from pane and watcherPane'.
	transmissions := self transmissions collect: [ :each | 
		newTransmission := each copy.
		newTransmission 
			changePortsAccordingToPaneMapping: newPanesMapping 
			fromOldBrowser: nil
			toNewBrowser: self.
		newTransmission ].
	panes := newPanes! !

!GLMBrowser methodsFor: 'accessing' stamp: 'TudorGirba 1/18/2011 14:23'!
removeAllPanes
	self panes do: [:each | each unregisterFromAllAnnouncements].
	^ self panes removeAll! !

!GLMBrowser methodsFor: 'accessing' stamp: 'tg 8/22/2010 21:33'!
removeLastPane
	self panes last unregisterFromAllAnnouncements.
	^ self panes removeLast! !

!GLMBrowser methodsFor: 'accessing' stamp: 'tg 1/31/2010 00:26'!
removePane: aPane
	aPane unregisterFromAllAnnouncements.
	self panes remove: aPane! !

!GLMBrowser methodsFor: 'announcements' stamp: 'TudorGirba 7/10/2011 17:00'!
resetAnnouncer
	super resetAnnouncer.
	self panes do: [:each | each resetAnnouncer ]! !

!GLMBrowser methodsFor: 'scripting-private' stamp: 'tg 10/25/2010 02:35'!
resolveDestinationPort: aPortReference 
	self flag: 'this is a temporary hack due to initializeScripting transmitting directly a port'.
	(aPortReference isKindOf: GLMPort) ifTrue: [ ^ aPortReference ].
	^self resolvePort: aPortReference asGlamourTargetIdentifier defaultPortName: #entity! !

!GLMBrowser methodsFor: 'scripting-private' stamp: 'tg 10/25/2010 02:21'!
resolveOriginPort: aPortReference 
	 
	^self resolvePort: aPortReference asGlamourOriginIdentifier defaultPortName: #selection! !

!GLMBrowser methodsFor: 'scripting-private' stamp: 'tg 10/25/2010 02:35'!
resolvePort: aPortReference defaultPortName: aSymbol 
	^ aPortReference paneName = #outer 
		ifTrue: [
			(GLMPresentationBoundPort new) 
						presentation: self; 
						name: aPortReference portName;
						yourself] 
		ifFalse: [
			(self paneNamed: aPortReference paneName) port: aPortReference portName].! !

!GLMBrowser methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
startOn: anObject 
	 
	self initializeScriptingDefaults. 
	self entity: anObject! !

!GLMBrowser methodsFor: 'accessing' stamp: 'tg 3/31/2010 19:33'!
transmissions 
	^ transmissions! !

!GLMBrowser methodsFor: 'scripting' stamp: 'tg 1/18/2010 13:29'!
transmit
	^ self addTransmission: (GLMTransmission new browser: self; yourself)! !

!GLMBrowser methodsFor: 'updating' stamp: 'TudorGirba 1/7/2011 07:25'!
unregisterFromAllAnnouncements
	super unregisterFromAllAnnouncements.
	self panes do: [:each | 
		each unregisterFromAllAnnouncements ]! !

!GLMBrowser methodsFor: 'updating' stamp: 'tg 8/24/2010 21:41'!
update 
	self panes do: [:each | each update ].
	self announce: (GLMPresentationUpdated new presentation: self).! !

!GLMBrowser methodsFor: 'accessing' stamp: 'TudorGirba 5/20/2012 23:40'!
watcherPane
	^ watcherPane ifNil: [watcherPane := GLMPane named: #'_watcher']! !

!GLMBrowser methodsFor: 'accessing' stamp: 'TudorGirba 5/20/2012 23:18'!
watcherPane: anObject
	watcherPane := anObject ! !

!GLMBrowser methodsFor: 'events' stamp: 'AndreiChis 10/29/2012 15:34'!
windowIsClosing 
	self announce: GLMWindowClosing new! !

!GLMBrowser methodsFor: 'enumerating' stamp: 'TudorGirba 7/9/2011 20:03'!
withAllPanesAndPresentationsDo: aBlock
	super withAllPanesAndPresentationsDo: aBlock.
	self panes do: [:each | each withAllPanesAndPresentationsDo: aBlock ]! !

GLMBrowser subclass: #GLMExplicitBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMExplicitBrowser commentStamp: 'TudorGirba 2/4/2011 17:50' prior: 0!
A GLMExplicitBrowser is a browser that allows the user to explicitly define the panes and the flow of transmissions between them.!

!GLMExplicitBrowser methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:48'!
addNewPane
	
	^self addNewPaneNamed: 'undefined'! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: 'tg 3/31/2010 22:49'!
addNewPaneNamed: aString
	^ self addPane: (GLMPane named: aString in: self)! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: 'tg 1/11/2010 20:39'!
custom: aPresentation 
	"this message sets a custom presentation to the current Transmission. 
	it is to be used within the using: block. 
	this message is particularly useful when you want to set a browser as a presentation" 
	 
	self lastTransmission addPresentation: aPresentation. 
	^ aPresentation! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: 'tg 1/11/2010 20:38'!
from: anOriginPortReference 
	"send this message after showOn: to specify an origin for the Transmission. 
	you can cascade several from: to specify additional origins" 
	 
	self lastTransmission 
		addActiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: 'TudorGirba 12/2/2010 20:10'!
fromOutside: aPortName
	 ^ self fromOutsidePort: aPortName! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: 'TudorGirba 12/2/2010 20:10'!
fromOutsidePort: aPortName
	 ^ self from: #outer->aPortName! !

!GLMExplicitBrowser methodsFor: 'events' stamp: 'DamienCassou 7/3/2011 19:52'!
innerPortEvent: aPortEvent
	| wantedTransmissions |
	aPortEvent hasChanged
		ifFalse: [ ^ self ].
	wantedTransmissions := self transmissions
		select: [ :each | (each originatesAt: aPortEvent port) and: [ (aPortEvent transmissionContext includesPort: each destination) not ] ].
	wantedTransmissions do: [ :each | each transmitIn: aPortEvent transmissionContext copy ]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: 'tg 1/11/2010 20:37'!
lastTransmission
	^ self transmissions last! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
paneNamed: aSymbol 
	 
	^self panes detect: [:each | each name = aSymbol]! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: 'tg 1/11/2010 20:38'!
passivelyFrom: anOriginPortReference 
	"passivelyForm: is similar to from: only the origin will be a passive one. 
	in other words, a change in the origin port will not initiate a Transmission" 
	 
	self lastTransmission
		addPassiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: 'tg 1/14/2010 16:10'!
sendTo: aDesinationPortReference from: anOriginPortReference 
	"this message links two port references with a transmission that holds no presentation" 
	 
	self transmissions 
		addLast: 
			((GLMTransmission new) 
				addActiveOrigin: (self resolveOriginPort: anOriginPortReference); 
				destination: (self resolveDestinationPort: aDesinationPortReference); 
				yourself)! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: 'tg 1/14/2010 16:10'!
sendTo: aDesinationPortReference from: anOriginPortReference with: aBlock 
	"this message links two port references with a transmission that holds no presentation" 
	 
	self transmissions 
		addLast: 
			((GLMTransmission new) 
				addActiveOrigin: (self resolveOriginPort: anOriginPortReference); 
				destination: (self resolveDestinationPort: aDesinationPortReference); 
				transformation: aBlock; 
				yourself)! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
sendTo: aDesinationPortReference fromOutside: anOriginPortName 
	"this is a shortcut method for propagating inside an outer port name to an inner port reference" 
	 
	self 
		sendTo: aDesinationPortReference 
		from: #outer -> anOriginPortName! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
sendToOutside: aPortName from: anOriginPortReference 
	"this is a shortcut method for exposing an inner port reference as an outer port name" 
	 
	self 
		sendTo: #outer -> aPortName 
		from: anOriginPortReference! !

!GLMExplicitBrowser methodsFor: 'scripting' stamp: 'DamienCassou 7/9/2011 20:19'!
showOn: aDestinationPane 
	"send this message when at the beginning of specifying a Transmission" 
	 
	self addTransmission: (
		GLMTransmission new
			ensureReplacePresentationsStrategy;
			destination: (self resolveDestinationPort: aDestinationPane); 
			yourself)! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 23:25'!
updateContextWith: aPane 
! !

GLMBrowser subclass: #GLMImplicitBrowser
	instanceVariableNames: 'presentations scriptTransmission'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMImplicitBrowser commentStamp: 'TudorGirba 3/5/2011 21:22' prior: 0!
A GLMImplicitBrowser is an abstract implementation of a browser that defines an implicit flow of transmissions.

When using implicit browsers, the developer does not have access to the internal transmissions.!

!GLMImplicitBrowser methodsFor: 'accessing' stamp: 'tg 1/17/2010 06:04'!
addPresentation: aPresentation
	self presentations add: aPresentation! !

!GLMImplicitBrowser methodsFor: 'accessing' stamp: 'TudorGirba 1/2/2012 01:49'!
presentations 
	 
	^ presentations ifNil: [presentations := GLMCompositePresentation new]! !

!GLMImplicitBrowser methodsFor: 'accessing' stamp: 'DamienCassou 7/9/2011 20:19'!
scriptTransmission
	^ scriptTransmission 
		ifNil: [scriptTransmission := GLMTransmission new ensureReplacePresentationsStrategy]! !

!GLMImplicitBrowser methodsFor: 'scripting' stamp: 'tg 1/17/2010 06:06'!
show: aBlock
	^ aBlock value: self presentations! !

GLMPresentation subclass: #GLMCompositePresentation
	instanceVariableNames: 'presentations arrangement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMCompositePresentation commentStamp: 'tg 2/20/2010 14:51' prior: 0!
A composite presentation offers means to control the composition of multiple presentations by providing the arrangement of these presentations.!

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'tg 1/6/2010 23:15'!
accordionArrangement
	^ self arrangement: GLMAccordionArrangement new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/31/2012 16:19'!
accumulator 
	^ self custom: GLMAccumulator new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
actionList
	^ self custom: GLMActionListPresentation new! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'TudorGirba 10/8/2011 16:39'!
add: aPresentation
	self pane notingPresentationChangeDo: [
		self presentations add: aPresentation.
		aPresentation pane: self pane ].
	^ aPresentation! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:11'!
allSatisfy: aBlock
	^ self presentations allSatisfy: aBlock ! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:11'!
anySatisfy: aBlock
	^ self presentations anySatisfy: aBlock ! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/12/2010 14:39'!
arrangement
	^ arrangement ifNil: [arrangement := GLMTabbedArrangement of: self]! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/6/2010 23:16'!
arrangement: anArrangement
	anArrangement composite: self.
	^ arrangement := anArrangement! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:14'!
at: aNumber
	^ self presentations at: aNumber ! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 5/25/2010 23:55'!
clear
	arrangement := nil.
	presentations := nil! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:16'!
collect: aBlock
	^ self copy presentations: (self presentations collect: aBlock ); yourself! !

!GLMCompositePresentation methodsFor: 'building' stamp: 'TudorGirba 9/9/2012 00:55'!
compose
	"by default this method is empty.
	override this method in subclasses to define a custom browser"! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
composite: aBlock
	| composite |
	composite := GLMCompositePresentation new.
	aBlock value: composite.
	^ self custom: composite! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'tg 1/5/2010 15:59'!
custom: aPresentation
	^ self add: aPresentation! !

!GLMCompositePresentation methodsFor: 'scripting opening' stamp: 'TudorGirba 10/7/2011 20:16'!
defaultRenderer 
	 
	^GLMRenderer subclasses first new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
diff
	^ self custom: GLMDiffPresentation new! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:12'!
do: aBlock
	^ self presentations do: aBlock ! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
dropDownList
	^ self custom: GLMDropDownListPresentation new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
dynamic
	^ self custom: GLMDynamicPresentation new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
eyesee
	^ self custom: GLMEyeSeePresentation new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
finder
	^ self custom: GLMFinder new! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:05'!
first
	^ self presentations first! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 21:09'!
includes: aPresentation
	^ self presentations includes: aPresentation ! !

!GLMCompositePresentation methodsFor: 'initialize-release' stamp: 'TudorGirba 9/9/2012 00:54'!
initialize 
	super initialize.
	self compose! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 15:17'!
isEmpty
	^ self presentations isEmpty! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
label
	^ self custom: GLMLabelPresentation new! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:28'!
last
	^ self presentations last! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
list 
	^ self custom: GLMListPresentation new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
magritte
	^ self custom: GLMMagrittePresentation new! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 21:09'!
matchingPresentations
	^ self presentations select: [:each | each matches]! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
mondrian 
	^ self custom: GLMMondrianPresentation new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
morph
	^ self custom: GLMMorphPresentation new! !

!GLMCompositePresentation methodsFor: 'scripting opening' stamp: 'TudorGirba 10/7/2011 20:16'!
open 
	 
	^self openWith: self defaultRenderer! !

!GLMCompositePresentation methodsFor: 'scripting opening' stamp: 'TudorGirba 10/7/2011 20:16'!
openOn: anObject 
	 
	^self 
		openOn: anObject 
		with: self defaultRenderer! !

!GLMCompositePresentation methodsFor: 'scripting opening' stamp: 'TudorGirba 10/7/2011 20:16'!
openOn: anObject with: aRenderer 
	 
	self startOn: anObject. 
	^ self openWith: aRenderer! !

!GLMCompositePresentation methodsFor: 'scripting opening' stamp: 'TudorGirba 10/7/2011 20:15'!
openWith: aRenderer 
	 
	^ aRenderer open: self! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'TudorGirba 10/8/2011 15:21'!
pane
	^ pane ifNil: [
		pane := (GLMPane named: 'root' in: GLMNoBrowser new) 
				presentations: self; 
				yourself]! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/6/2010 11:56'!
pane: aPane 
	super pane: aPane.
	self presentations do: [:each | each pane: aPane ]! !

!GLMCompositePresentation methodsFor: 'comparison' stamp: 'TudorGirba 7/10/2011 13:08'!
postCopy
	super postCopy.
	presentations ifNotNil: [ :arg | 
		presentations := presentations collect: [ :each | each copy ] ].
	arrangement ifNotNil: [ :arg | 
		arrangement := arrangement copy.
		arrangement composite: self ]! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 12/16/2009 17:45'!
presentations
	^ presentations ifNil: [presentations := OrderedCollection new]! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 12/14/2009 23:55'!
presentations: anObject
	presentations := anObject! !

!GLMCompositePresentation methodsFor: 'rendering' stamp: 'tg 1/18/2010 21:31'!
renderGlamorouslyOn: aRenderer
	"we delegate to the arrangement to dispatch the type of the actual arrangement of the nested presentations"
	self registerAnnouncements.
	^ self arrangement renderGlamorouslyOn: aRenderer! !

!GLMCompositePresentation methodsFor: 'announcements' stamp: 'tg 1/30/2010 23:31'!
resetAnnouncer
	super resetAnnouncer.
	self presentations do: [:each | each resetAnnouncer ]! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:11'!
select: aBlock
	^ self presentations select: aBlock! !

!GLMCompositePresentation methodsFor: 'accessing' stamp: 'tg 1/5/2010 16:13'!
size
	^ self presentations size! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
smalltalkCode
	^ self custom: GLMSmalltalkCodePresentation new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'tg 1/14/2010 02:56'!
stackedArrangement
	^ self stackedVerticallyArrangement! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'tg 1/12/2010 14:37'!
stackedVerticallyArrangement
	^ self arrangement: (GLMStackedVerticallyArrangement of: self)! !

!GLMCompositePresentation methodsFor: 'scripting opening' stamp: 'TudorGirba 10/7/2011 20:16'!
startOn: anObject 
	
	self entity: anObject! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'tg 1/14/2010 17:21'!
tabbedArrangement
	^ self arrangement: GLMTabbedArrangement new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
table
	^ self custom: GLMTablePresentation new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
tabulator
	^ self custom: GLMTabulator new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
text 
	^ self custom: GLMTextPresentation new! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/2/2012 01:15'!
tree 
	^ self custom: GLMTreePresentation new! !

!GLMCompositePresentation methodsFor: 'announcements' stamp: 'tg 1/31/2010 00:26'!
unregisterFromAllAnnouncements
	super unregisterFromAllAnnouncements.
	self presentations do: [:each | each unregisterFromAllAnnouncements ]! !

!GLMCompositePresentation methodsFor: 'updating' stamp: 'tg 8/24/2010 21:41'!
update
	self pane ports do: [:each |
		(self validate: each value on: each) ifFalse: [each resetValue] ].
	self presentations do: [ :each | each update ].
	self announce: (GLMPresentationUpdated new presentation: self).! !

!GLMCompositePresentation methodsFor: 'scripting' stamp: 'tg 1/12/2010 14:37'!
verticallyStackedArrangement
	^ self stackedVerticallyArrangement! !

!GLMCompositePresentation methodsFor: 'enumerating' stamp: 'tg 1/11/2010 17:24'!
withAllDo: aBlock
	super withAllDo: aBlock.
	self do: aBlock! !

!GLMCompositePresentation methodsFor: 'enumerating' stamp: 'TudorGirba 7/9/2011 20:06'!
withAllPanesAndPresentationsDo: aBlock
	super withAllPanesAndPresentationsDo: aBlock.
	self do: [:each | each withAllPanesAndPresentationsDo: aBlock ]! !

GLMPresentation subclass: #GLMFormatedPresentation
	instanceVariableNames: 'format icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMFormatedPresentation commentStamp: 'TudorGirba 2/4/2011 17:56' prior: 0!
GLMFormatedPresentation is an abstract presentation that offers a format block to be used for formatting the rendering of the presentation. The renderer will use the formatDisplayValueOf: method.!

!GLMFormatedPresentation methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:55'!
format
	^ format ifNil: [ format := #glamourString ]! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
format: anObject 
	 
	format := anObject! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: 'tg 9/9/2009 00:58'!
formatedDisplayValue
	^ self format glamourValue: self displayValue! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: 'tg 9/9/2009 01:03'!
formatedDisplayValueOf: anObject
	^ self format glamourValue: (anObject asGlamorousMultiValue, self entity asGlamorousMultiValue)! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:56'!
icon
	^ icon ifNil: [ icon := [nil] ]! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:55'!
icon: anObject
	icon := anObject! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:56'!
iconFor: anObject
	^ self icon glamourValue: (anObject asGlamorousMultiValue, self entity asGlamorousMultiValue)! !

GLMFormatedPresentation subclass: #GLMLabelPresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMLabelPresentation methodsFor: 'rendering' stamp: 'tg 3/30/2010 23:06'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderLabelPresentation: self! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 4/1/2010 07:15'!
acceptsSelection
	"this flag is used to specify whether the presentation
	is allowed to populate the selection port or not"
	^ acceptsSelection ifNil: [acceptsSelection := true]! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 12/29/2009 02:16'!
acceptsSelection: aBoolean
	acceptsSelection := aBoolean! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:54'!
act: aBlock entitled: aString 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:54'!
act: aBlock entitled: aString categorized: anotherString
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:53'!
act: aBlock icon: anIcon entitled: aString
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 3/5/2011 23:46'!
act: aBlock icon: anIcon on: aCharacter entitled: aString
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 				
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:53'!
act: aBlock on: aCharacter 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:53'!
act: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:54'!
act: aBlock on: aCharacter entitled: aString categorized: anotherString 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: 'accessing' stamp: 'TudorGirba 2/11/2011 23:04'!
actions
	"These are actions that make sense for the entire presentation."
	actions ifNil: [actions := OrderedCollection new].
	^ actions! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 11/27/2010 12:37'!
actions: aBlock 
	self deprecated: 'use dynamicActionsOnSelection: for contextual actions, and dynamicActions for presentation-wide actions'.
	^ self dynamicActionsOnSelection: aBlock ! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addAction: anAction 
	 
	self actions addLast: anAction! !

!GLMPresentation methodsFor: 'statusbar' stamp: 'TudorGirba 10/8/2011 18:47'!
addDefaultStatusbarTransmissionFrom: aPane
	| defaultTransmission |
	defaultTransmission := GLMTransmission new
		ensureReplacePresentationsStrategy;
		addActiveOrigin: (aPane port: #status); 
		destination: (self statusbarPane port: #entity); 
		addPresentation: self statusbarPresentation; 
		yourself.
	self addTransmission: defaultTransmission.! !

!GLMPresentation methodsFor: 'accessing' stamp: 'cyrilledelaunay 8/9/2011 11:18'!
addOpenBrowserAction: anAction 
	 
	self openBrowserActions addLast: anAction! !

!GLMPresentation methodsFor: 'transmitting' stamp: 'DamienCassou 7/19/2011 20:36'!
addRawSelectionTransmissionTo: aPortSymbol
	^ rawSelectionTransmissions
		add:
			((GLMTransmission new)
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								name: #rawSelection;
								presentation: self;
								yourself);
				destination:
						((GLMPresentationBoundPort new)
								name: aPortSymbol;
								presentation: self;
								yourself))! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 11/19/2010 18:15'!
addSelectionAction: anAction
	self selectionActions add: anAction! !

!GLMPresentation methodsFor: 'accessing' stamp: 'cyrilledelaunay 8/9/2011 11:18'!
addSelectionOpenBrowserAction: anAction
	self selectionOpenBrowserActions add: anAction! !

!GLMPresentation methodsFor: 'statusbar' stamp: 'TudorGirba 10/8/2011 18:47'!
addStatusbar
	self hasStatusbar: true
	! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 8/4/2009 15:19'!
allActions 
	^ self actions, self dynamicActions! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 11/19/2010 18:15'!
allSelectionActions 
	^ self selectionActions, self dynamicActionsOnSelection! !

!GLMPresentation methodsFor: 'scripting' stamp: 'VeronicaUquillas 2/18/2011 15:20'!
allowAllNil
	^ self useExplicitAllNil! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/18/2009 15:34'!
allowNil
	^ self useExplicitNotNil! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 11/6/2009 20:08'!
color
	^ color! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 11/6/2009 20:08'!
color: aSymbolOrColor
	color := aSymbolOrColor! !

!GLMPresentation methodsFor: 'accessing values' stamp: 'tg 11/6/2009 20:08'!
colorValue
	^ self color notNil
		ifTrue: [ self color glamourValue: self entity ]
		ifFalse: [ self color ]
"
	
	self color isSymbol
		ifTrue: [ Color perform: self color ]
		ifFalse: [ self color ]"! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
condition 
	 
	^condition ifNil: [condition := [true]]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
condition: anObject 
	 
	condition := anObject! !

!GLMPresentation methodsFor: 'copying' stamp: 'TudorGirba 7/11/2011 11:18'!
copy
	"we are overriding the copy method simply to retain the tree of all prototype presentations. 
	this is useful for debugging."

	| copy |
	self flag: 'perhaps this should be replaced with smarter analysys mechanisms'.
	copy := super copy.
	copy parentPrototype: self.
	^ copy! !

!GLMPresentation methodsFor: 'accessing validation' stamp: 'tg 11/15/2009 16:14'!
customValidation
	^ customValidation! !

!GLMPresentation methodsFor: 'accessing validation' stamp: 'tg 11/15/2009 23:52'!
customValidation: aBlock
	customValidation := aBlock.
	shouldValidate := true.! !

!GLMPresentation methodsFor: 'validation' stamp: 'TudorGirba 3/5/2011 21:20'!
defaultValidate: anObject on: aPort 
	"by default any object is allowed in any port"
	"override this method in subclasses to specify stronger constraints"
	^ true! !

!GLMPresentation methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
display: aBlock 
	 
	self transformation: aBlock! !

!GLMPresentation methodsFor: 'accessing values' stamp: 'tg 8/1/2009 16:49'!
displayValue
	^ self transformation glamourValue: self entity! !

!GLMPresentation methodsFor: 'validation' stamp: 'tg 11/15/2009 23:46'!
doValidate: anObject on: aPort 
	^ self customValidation isNil ifFalse: [ 
		self customValidation glamourValue: (
			anObject asGlamorousMultiValue,
			aPort name asGlamorousMultiValue, 
			self entity asGlamorousMultiValue) ]
	ifTrue: [ self defaultValidate: anObject on: aPort ]! !

!GLMPresentation methodsFor: 'accessing' stamp: 'TudorGirba 2/11/2011 23:04'!
dynamicActions
	"These are actions that make sense for the entire presentation.
	They are dynamic in the sense that they will be evaluated lazily by the renderer"
	dynamicActionsBlock isNil ifTrue: [ ^ OrderedCollection new ].
	^ dynamicActionsBlock glamourValue: self! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/19/2010 18:27'!
dynamicActions: aBlock 
	dynamicActionsBlock := aBlock! !

!GLMPresentation methodsFor: 'accessing' stamp: 'TudorGirba 2/11/2011 23:04'!
dynamicActionsOnSelection
	"These are actions that make sense only in the context of values held in the selection port.
	They are dynamic in the sense that they will be evaluated lazily by the renderer"
	selectionDynamicActionsBlock isNil ifTrue: [ ^ OrderedCollection new ].
	^ selectionDynamicActionsBlock glamourValue: self! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 11/14/2010 18:19'!
dynamicActionsOnSelection: aBlock
	selectionDynamicActionsBlock := aBlock! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'tg 12/29/2009 00:31'!
entity
	^ (self pane port: #entity) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'tg 12/29/2009 00:31'!
entity: anObject
	(self pane port: #entity) value: anObject! !

!GLMPresentation methodsFor: 'testing' stamp: 'TudorGirba 1/31/2011 02:08'!
hasActions
	^ self allActions notEmpty! !

!GLMPresentation methodsFor: 'statusbar' stamp: 'TudorGirba 10/8/2011 18:47'!
hasStatusbar
	^ statusPane notNil! !

!GLMPresentation methodsFor: 'statusbar' stamp: 'TudorGirba 10/8/2011 18:47'!
hasStatusbar: aBoolean
	aBoolean ifTrue: [
		statusPane := self addPane: (GLMPane new name: self class defaultStatusbarPane) ]
	! !

!GLMPresentation methodsFor: 'testing' stamp: 'tg 1/13/2010 22:28'!
hasTitle
	^ title notNil! !

!GLMPresentation methodsFor: 'testing' stamp: 'tg 9/30/2009 23:51'!
hasTitleIcon
	^ self titleIcon notNil! !

!GLMPresentation methodsFor: 'initialize-release' stamp: 'TudorGirba 5/20/2012 23:19'!
initialize
	super initialize.
	updateActions := OrderedCollection new.
	rawSelectionTransmissions := IdentitySet new.
	self addRawSelectionTransmissionTo: #selection! !

!GLMPresentation methodsFor: 'events' stamp: 'tg 2/22/2010 13:11'!
innerPortEvent: aPortEvent 
	 "Regular presentations do not have inner ports,
	  so the default behaviour is to do nothing"! !

!GLMPresentation methodsFor: 'testing' stamp: 'DamienCassou 7/9/2011 23:16'!
matches 
	"answer true iff the presentation matches the current context so that it can be displayed"
	^ (self usesImplicitAllNil
	    ifTrue:[ GLMAllNilCondition new glamourValue: self entity ]
	    ifFalse:[ self usesImplicitNotNil 
			ifTrue: [GLMAllNotNilCondition new glamourValue: self entity] 
			ifFalse: [GLMSomeNotNilCondition new glamourValue: self entity] ]
		) and: [
			(self condition glamourValue: self entity) = true]! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/26/2010 13:39'!
morphicAct: aBlock entitled: aString 
	 
	self addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/31/2011 00:57'!
morphicAct: aBlock icon: anIcon entitled: aString 
	 
	self addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				title: aString; 
				icon: anIcon;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/24/2010 16:09'!
morphicAct: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/31/2011 22:51'!
morphicAct: aBlock on: aCharacter icon: anIcon entitled: aString 
	 
	self 
		addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				icon: anIcon;
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 2/5/2011 00:38'!
morphicPopulate: aPortSymbol icon: anIcon on: aCharacter entitled: aString with: aBlock 
	 
	self 
		addAction: 
			((GLMMorphicAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 11/25/2010 00:11'!
morphicSelectionAct: aBlock entitled: aString 
	 
	self addSelectionAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 1/30/2011 20:18'!
morphicSelectionAct: aBlock icon: anIcon entitled: aString
	self 
		addSelectionAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 8/21/2011 09:33'!
morphicSelectionAct: aBlock icon: anIcon on: aCharacter entitled: aString
	self 
		addSelectionAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				shortcut: aCharacter; 				
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 12/29/2009 02:16'!
noSelection
	self acceptsSelection: false! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 9/27/2012 07:08'!
noTitle
	title := nil.
	titleIcon := nil! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 9/27/2012 22:24'!
noTitleIcon
	titleIcon := nil! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:53'!
open: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'events' stamp: 'tg 5/24/2010 16:53'!
outerPortEvent: aPortEvent
	self announce: (GLMContextChanged new
				presentation: self; 
				property: aPortEvent portName; 
				value: aPortEvent value; 
				oldValue: aPortEvent oldValue; 
				yourself)! !

!GLMPresentation methodsFor: 'accessing' stamp: 'TudorGirba 7/14/2011 15:39'!
pane
	^ pane ifNil: [
		pane := (GLMPane named: 'root' in: GLMNoBrowser new) 
				addPresentationSilently: self; 
				yourself]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane: aPane 
	 
	pane := aPane! !

!GLMPresentation methodsFor: 'copying' stamp: 'tg 1/11/2010 22:33'!
parentPrototype
	^ parentPrototype! !

!GLMPresentation methodsFor: 'copying' stamp: 'TudorGirba 2/11/2011 22:59'!
parentPrototype: aPresentation
	"used to keep track of the (prototype) presentation from which
	the current one was copied"
	parentPrototype := aPresentation! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:54'!
populate: aPortSymbol icon: anIcon entitled: aString with: aBlock 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				icon: anIcon; 
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 2/4/2011 22:05'!
populate: aPortSymbol icon: anIcon on: aCharacter entitled: aString with: aBlock 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/19/2010 18:13'!
populate: aPortSymbol on: aCharacter entitled: aString with: aBlock 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 9/25/2010 17:54'!
populate: aPortSymbol on: aCharacter with: aBlock
	self addAction: 
			((GLMGenericAction new) 
				action: ((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: 'copying' stamp: 'DamienCassou 7/19/2011 20:06'!
postCopy
	super postCopy.
	pane := nil.
	self flag: 'self unregisterFromAllAnnouncements.'.
	updateActions := updateActions
		collect: [ :each | 
			(each copy)
				presentation: self;
				yourself ].
	rawSelectionTransmissions := rawSelectionTransmissions collect: [:each | each copy].
	rawSelectionTransmissions do: [:transmission | transmission originReferences do: [:portRef | portRef port presentation: self]].
	rawSelectionTransmissions do: [:transmission | transmission destination presentation: self]! !

!GLMPresentation methodsFor: 'printing' stamp: 'DamienCassou 7/3/2011 20:02'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: '(id=';
		nextPutAll: self identityHash printString;
		nextPutAll: ' title=';
		nextPutAll: self titleValue asString;
		nextPutAll: ' pane=';
		nextPutAll: self pane printString;
		nextPutAll: ')'! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'TudorGirba 9/24/2012 08:10'!
rawSelection
	^ (self pane port: #rawSelection) value! !

!GLMPresentation methodsFor: 'transmitting' stamp: 'DamienCassou 7/19/2011 20:48'!
rawSelectionTransmissionFor: aPortSymbol ifNone: ifNoneBlock
	^ rawSelectionTransmissions
		detect: [ :transmission | transmission destination port name = aPortSymbol ]
		ifNone: ifNoneBlock! !

!GLMPresentation methodsFor: 'updating' stamp: 'TudorGirba 7/10/2011 12:49'!
registerAnnouncements
	"this method is called from the rendering code"
	self flag: 'The announcements should potentially be interested in any ports, not just in entity'.
	updateActions do: [:each | each registerInPresentation ].! !

!GLMPresentation methodsFor: 'updating' stamp: 'tg 1/30/2010 23:22'!
registeredAnnouncers
	^ registeredAnnouncers ifNil: [registeredAnnouncers := OrderedCollection new]! !

!GLMPresentation methodsFor: 'rendering' stamp: 'tg 11/8/2009 00:24'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^aRenderer renderPresentation: self! !

!GLMPresentation methodsFor: 'copying' stamp: 'tg 1/11/2010 22:32'!
rootPrototype
	^ self parentPrototype isNil 
		ifTrue: [ self ] 
		ifFalse: [ self parentPrototype rootPrototype ]
! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'tg 12/29/2009 00:31'!
selection
	^ (self pane port: #selection) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'DamienCassou 7/19/2011 21:09'!
selection: anObject
	"Tell the pane about the new selection. This method is called when the user changes a view's selection' (e.g., he clicks on an element in a list morph)." 
	self acceptsSelection ifFalse: [^ self].
	(self pane port: #rawSelection) value: anObject.
	rawSelectionTransmissions do: #transmit! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/20/2010 20:15'!
selectionAct: aBlock entitled: aString 
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/20/2010 20:14'!
selectionAct: aBlock entitled: aString categorized: anotherString
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/20/2010 20:16'!
selectionAct: aBlock icon: anIcon entitled: aString
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/20/2010 20:13'!
selectionAct: aBlock on: aCharacter 
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/19/2010 18:16'!
selectionAct: aBlock on: aCharacter entitled: aString 
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'accessing' stamp: 'TudorGirba 2/11/2011 23:04'!
selectionActions
	"These are actions that make sense only in the context of values held in the selection port."
	^ selectionActions ifNil: [ selectionActions := OrderedCollection new ]! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 11/19/2010 18:16'!
selectionActions: anObject
	selectionActions := anObject! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 11/19/2010 18:13'!
selectionPopulate: aPortSymbol on: aCharacter entitled: aString with: aBlock 
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 12/16/2011 17:40'!
selectionSpawn: aBlock entitled: aString 
	 
	"These are actions that return a glamour browser to open at the end."
	self 
		addSelectionAction: 
			((GLMSpawnBrowserAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'transmitting' stamp: 'DamienCassou 7/19/2011 21:16'!
selectionTransformation
	"this is used for transforming the object before updating the selection"
	^ self selectionTransmission transformation ifNil: [#yourself]! !

!GLMPresentation methodsFor: 'transmitting' stamp: 'DamienCassou 7/19/2011 20:11'!
selectionTransformation: anObject 
	self selectionTransmission 	transformation: anObject ! !

!GLMPresentation methodsFor: 'transmitting' stamp: 'DamienCassou 7/19/2011 20:50'!
selectionTransmission
	^ self rawSelectionTransmissionFor: #selection ifNone: [nil]! !

!GLMPresentation methodsFor: 'scripting' stamp: 'tg 8/25/2009 16:01'!
send: aBlock 
	self selectionTransformation: aBlock! !

!GLMPresentation methodsFor: 'scripting' stamp: 'DamienCassou 7/19/2011 20:49'!
send: aBlock as: aPortSymbol
	(self
			rawSelectionTransmissionFor: aPortSymbol
			ifNone: [ self addRawSelectionTransmissionTo: aPortSymbol ])
		transformation: aBlock! !

!GLMPresentation methodsFor: 'accessing validation' stamp: 'tg 11/15/2009 23:47'!
shouldValidate
	^ shouldValidate ifNil: [shouldValidate := false]! !

!GLMPresentation methodsFor: 'accessing validation' stamp: 'tg 11/15/2009 23:50'!
shouldValidate: aBoolean
	shouldValidate := aBoolean ! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 12/16/2011 17:40'!
spawn: aBlock entitled: aString 
	"These are actions that return a glamour browser to open at the end."
	self 
		addAction: 
			((GLMSpawnBrowserAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 12/16/2011 17:40'!
spawn: aBlock icon: anIcon entitled: aString
	self 
		addAction: 
			((GLMSpawnBrowserAction new) 
				action: aBlock; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'DamienCassou 7/19/2011 21:16'!
status: anObject 
	self flag: 'what kind of transformation should we want here?'.
	(self pane port: #status) value: (self selectionTransformation glamourValue: anObject)! !

!GLMPresentation methodsFor: 'statusbar' stamp: 'TudorGirba 10/8/2011 18:47'!
statusbarPane
	^ statusPane! !

!GLMPresentation methodsFor: 'statusbar' stamp: 'TudorGirba 10/8/2011 18:47'!
statusbarPresentation
	^ GLMLabelPresentation new! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'tg 12/29/2009 00:31'!
strongSelection
	^ (self pane port: #strongSelection) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'DamienCassou 7/19/2011 21:16'!
strongSelection: anObject
	(self pane port: #strongSelection) value: (self selectionTransformation glamourValue: anObject)! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 1/14/2010 02:47'!
title
	^ title! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
title: aStringOrBlock 
	 
	title := aStringOrBlock! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 9/30/2009 23:51'!
titleIcon
	^ titleIcon! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 9/30/2009 23:51'!
titleIcon: anObject
	titleIcon := anObject! !

!GLMPresentation methodsFor: 'accessing values' stamp: 'tg 11/1/2009 22:16'!
titleIconValue
	^ self titleIcon notNil
		ifTrue: [ self titleIcon glamourValue: self entity ]
		ifFalse: [ self titleIcon ]! !

!GLMPresentation methodsFor: 'accessing values' stamp: 'tg 1/14/2010 02:47'!
titleValue
	^ self title glamourValue: self entity! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transformation 
	 
	^transformation ifNil: [transformation := #yourself]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transformation: aBlock 
	 
	transformation := aBlock! !

!GLMPresentation methodsFor: 'updating' stamp: 'tg 5/3/2010 00:15'!
unregisterFromAllAnnouncements
	"this method should be called every time the presentation is not needed"
	updateActions do: [ :each | each unregisterFromAllAnnouncements ]! !

!GLMPresentation methodsFor: 'updating' stamp: 'tg 8/24/2010 21:40'!
update
	self pane ports do: [:each |
		(self validate: each value on: each) ifFalse: [each resetValue] ].
	self announce: (GLMPresentationUpdated new presentation: self)! !

!GLMPresentation methodsFor: 'updating' stamp: 'tg 5/3/2010 01:33'!
updateOn: anAnnouncement from: aBlockOrSymbol 
	updateActions add: (GLMSingleUpdateAction new 
		presentation: self;
		announcement: anAnnouncement; 
		transformation: aBlockOrSymbol;
		yourself)! !

!GLMPresentation methodsFor: 'updating' stamp: 'tg 5/3/2010 01:33'!
updateOn: anAnnouncement from: aBlockOrSymbol when: aConditionBlock
	updateActions add: (GLMSingleUpdateAction new
		presentation: self; 
		announcement: anAnnouncement; 
		transformation: aBlockOrSymbol;
		condition: aConditionBlock;
		yourself)! !

!GLMPresentation methodsFor: 'updating' stamp: 'tg 5/3/2010 01:33'!
updateOn: anAnnouncement fromAll: aBlockOrSymbol 
	updateActions add: (GLMMultipleUpdateAction new
		presentation: self; 
		announcement: anAnnouncement; 
		transformation: aBlockOrSymbol;
		yourself)! !

!GLMPresentation methodsFor: 'accessing' stamp: 'VeronicaUquillas 2/18/2011 15:14'!
useExplicitAllNil 
	 
	implicitAllNil := true! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
useExplicitNotNil 
	 
	implicitNotNil := false! !

!GLMPresentation methodsFor: 'accessing' stamp: 'VeronicaUquillas 2/18/2011 15:15'!
useImplicitAllNil 
	 
	implicitAllNil := true! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
useImplicitNotNil 
	 
	implicitNotNil := true! !

!GLMPresentation methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
usesExplicitNotNil 
	 
	^self usesImplicitNotNil not! !

!GLMPresentation methodsFor: 'testing' stamp: 'VeronicaUquillas 2/18/2011 15:25'!
usesImplicitAllNil
	 
	^implicitAllNil ifNil: [implicitAllNil := false ]! !

!GLMPresentation methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
usesImplicitNotNil 
	 
	^implicitNotNil ifNil: [implicitNotNil := true]! !

!GLMPresentation methodsFor: 'validation' stamp: 'TudorGirba 2/11/2011 22:45'!
validate: anObject on: aPort 
	"This gets triggered when aPort wants to be changed.
	The presentation has a chance to veto the value."
	self shouldValidate ifFalse: [ ^ true ].
	^ self doValidate: anObject on: aPort.! !

!GLMPresentation methodsFor: 'accessing' stamp: 'TudorGirba 5/20/2012 23:18'!
watcherPane
	^ nil! !

!GLMPresentation methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
when: aBlock 
	 
	self condition: aBlock! !

!GLMPresentation methodsFor: 'scripting' stamp: ' 4/5/09 22:18'!
whenKindOf: aClass 
	 
	self when: [:each | each isKindOf: aClass]! !

!GLMPresentation methodsFor: 'scripting' stamp: 'TudorGirba 7/29/2012 08:50'!
with: aBlock
	aBlock value: self! !

!GLMPresentation methodsFor: 'enumeration' stamp: 'tg 1/11/2010 17:24'!
withAllDo: aBlock
	^ aBlock value: self! !

!GLMPresentation methodsFor: 'enumerating' stamp: 'TudorGirba 7/10/2011 01:03'!
withAllPanes
	| result |
	result := OrderedCollection new.
	self withAllPanesAndPresentationsDo: [:each |
		(each isKindOf: GLMPane) ifTrue: [ result add: each ]].
	^ result! !

!GLMPresentation methodsFor: 'enumeration' stamp: 'TudorGirba 7/9/2011 20:00'!
withAllPanesAndPresentationsDo: aBlock
	^ aBlock value: self! !

!GLMPresentation methodsFor: 'enumerating' stamp: 'TudorGirba 7/9/2011 22:28'!
withAllPresentations
	| result |
	result := OrderedCollection new.
	self withAllPanesAndPresentationsDo: [:each |
		(each isKindOf: GLMPresentation) ifTrue: [ result add: each ]].
	^ result! !

GLMLoggedObject subclass: #GLMTransmission
	instanceVariableNames: 'context destination browser origins transmissionStrategy transformation condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMTransmission commentStamp: 'DamienCassou 7/19/2011 16:53' prior: 0!
A GLMTransmission models the connection between multiple origin ports and one destination port. Whenever an origin port changes the value, the corresponding transmissions are triggered by the browser.

The result of triggering a transmission is the setting of the value in the destination port. The transmissionStrategy can add further different semantics to this behavior.

A transmission takes place in a context. The context is started every time a new value is set from outside. Afterwards, the context is preserved internally. This is important for braking possible loops of transmission propagation.

There are two kind of origins for a transmission, active and passive ones. A change of value in an active origin will trigger the transmissions originating from it. A change of value in a passive origin will not trigger the transmission. However, a value in a passive origin is still part of the transmission value.!

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 12:24'!
activeOrigins 
	 
	^(self originReferences select: [:each | each isActive]) 
		collect: [:each | each port]! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 16:07'!
addActiveOrigin: aPort 
	^ self originReferences 
		add: 
			((GLMOriginPortReference new) 
				port: aPort; 
				beActive; 
				yourself)! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 16:07'!
addPassiveOrigin: aPort
	^ self originReferences 
		add: 
			((GLMOriginPortReference new) 
				port: aPort; 
				bePassive; 
				yourself)! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 16:53'!
addPresentation: aPresentation
	self transmissionStrategy addPresentation: aPresentation! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 17:07'!
addPresentations: aCollection
	self transmissionStrategy addPresentations: aCollection! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 1/3/2012 16:16'!
andShow: aBlock
	"This method accepts a block with one argument.
	The block will be evaluated with an instance of GLMCompositePresentation.
	
	The block should construct the presentations that go in the composite presentation.
	The composite presentation will be the one that will get installed in the target pane
	once the transmission triggers.

	This method is meant to be used in a Glamour script.
	"
	
	self ensureReplacePresentationsStrategy.
	self origins isEmpty
		ifTrue: [ self from: #outer port: #entity ].
	aBlock value: self transmissionStrategy presentations! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 1/3/2012 16:16'!
andShowIfNone: aBlock
	"This method accepts a block with one argument. 
	The block will be evaluated with an instance of GLMCompositePresentation.
	
	The block should construct the presentations that go in the composite presentation.
	The composite presentation will be the one that will get installed in the target pane
	once the transmission triggers.
	
	The particularity of this method is that the presentation will get installed in the target
	pane only if the target pane has no presentation already.

	This method is meant to be used in a Glamour script.
	"

	self ensurePresentIfNoneStrategy.
	self origins isEmpty
		ifTrue: [ self from: #outer port: #entity ].
	aBlock value: self transmissionStrategy presentations! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/5/2010 14:52'!
browser
	^ browser! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/5/2010 14:52'!
browser: anObject
	browser := anObject! !

!GLMTransmission methodsFor: 'copying' stamp: 'tg 12/30/2009 02:06'!
changePortsAccordingToPaneMapping: newPanesMapping
	"newPanesMapping is a dictionary with 
	keys given by old panes and values by new panes"
	self destination: ((newPanesMapping at: self destination pane) port: self destination name).
! !

!GLMTransmission methodsFor: 'copying' stamp: 'lr 6/4/2010 14:04'!
changePortsAccordingToPaneMapping: newPanesMapping fromOldBrowser: aBrowser toNewBrowser: anotherBrowser
	| newPort |
	"newPanesMapping is a dictionary with 
	keys given by old panes and values by new panes"
	self destination: (self destination copyAccordingToPaneMapping: newPanesMapping inNewBrowser: anotherBrowser).
	self originReferences do: [:each | 
		newPort := each port copyAccordingToPaneMapping: newPanesMapping inNewBrowser: anotherBrowser.
		each port: newPort ]! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/31/2010 01:39'!
condition
	^ condition! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/31/2010 01:22'!
condition: anObject
	condition := anObject! !

!GLMTransmission methodsFor: 'transmitting' stamp: 'jre 9/18/2009 19:17'!
context
	 context ifNil: [context := OrderedCollection new].
	^context! !

!GLMTransmission methodsFor: 'transmitting' stamp: 'jre 9/18/2009 19:46'!
context: aContext
	 context := aContext! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 12/30/2009 02:07'!
destination 
	 
	^destination! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 12/30/2009 02:07'!
destination: aPort 
	 
	destination := aPort! !

!GLMTransmission methodsFor: 'accessing' stamp: 'DamienCassou 7/9/2011 20:20'!
ensurePresentIfNoneStrategy
	self transmissionStrategy class = GLMPresentIfNoneStrategy ifFalse: [
		self transmissionStrategy: (GLMPresentIfNoneStrategy of: self) ]! !

!GLMTransmission methodsFor: 'accessing' stamp: 'DamienCassou 7/9/2011 20:19'!
ensureReplacePresentationsStrategy
	self transmissionStrategy class = GLMReplacePresentationsStrategy ifFalse: [
		self transmissionStrategy: (GLMReplacePresentationsStrategy of: self) ]! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 5/1/2011 01:56'!
from: aPort
	"Ideally this method would be implemented as
	^ self from: aPaneSymbol port: #selection.
	
	The problem is that beforehand we only had from: which could receive either a symbol for the pane, or an association for the port. This was bad, and now Glamour offers from:port:, but there are still legacy cases of from: being called with an association."

	^ self addActiveOrigin: (self browser resolveOriginPort: aPort)! !

!GLMTransmission methodsFor: 'scripting' stamp: 'tg 11/3/2010 13:37'!
from: aPaneSymbol port: aPortSymbol
	^ self from: (GLMPortIdentifier pane: aPaneSymbol port: aPortSymbol)! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 2/23/2011 23:53'!
from: aPaneSymbol port: aPortSymbol transformed: aBlock
	^ (self from: (GLMPortIdentifier pane: aPaneSymbol port: aPortSymbol)) transformation: aBlock! !

!GLMTransmission methodsFor: 'scripting' stamp: 'tg 1/14/2010 23:26'!
from: aPort transformed: aBlock
	^ (self addActiveOrigin: (self browser resolveOriginPort: aPort)) transformation: aBlock! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 5/20/2012 00:55'!
fromOutside: aPortSymbol
	self deprecated: 'Use fromOutsidePort: instead'.
	^ self fromOutsidePort: aPortSymbol! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 10/2/2011 21:39'!
fromOutsideEntityPort
	^ self fromOutsidePort: #entity! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 10/2/2011 21:40'!
fromOutsideEntityPortTransformed: aBlock
	^ self fromOutsidePort: #entity transformed: aBlock! !

!GLMTransmission methodsFor: 'scripting' stamp: 'DamienCassou 7/10/2011 10:53'!
fromOutsidePort: aPortSymbol
	^ self from: #outer port: aPortSymbol! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 10/2/2011 21:40'!
fromOutsidePort: aPortSymbol transformed: aBlock
	^ self from: #outer port: aPortSymbol transformed: aBlock! !

!GLMTransmission methodsFor: 'initialize-release' stamp: 'tg 5/24/2010 17:19'!
initialize
	super initialize.
	transmissionStrategy := GLMNoStrategy new.
	condition := true! !

!GLMTransmission methodsFor: 'testing' stamp: 'tg 1/31/2010 01:38'!
meetsCondition
	| originValues |
	originValues := self originReferences size = 1 
		ifTrue: [ self originReferences first value ] 
		ifFalse: [ GLMMultiValue withAll: (self originReferences collect: [:each | each value]) ].
	^ self condition glamourValue: originValues! !

!GLMTransmission methodsFor: 'private accessing' stamp: 'DamienCassou 7/9/2011 22:43'!
originReferences
	"Returns the set of ports (instances of PortReference) the transmission receives its data from"
	^ origins ifNil: [origins := OrderedCollection new]! !

!GLMTransmission methodsFor: 'testing' stamp: 'tg 1/31/2010 01:28'!
originatesAt: aPort
	^ (self activeOrigins includes: aPort) and: [self meetsCondition]! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 12:20'!
origins
	^ self originReferences collect: [:each | each port]! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 12:23'!
passiveOrigins 
	 
	^(self originReferences select: [:each | each isPassive]) 
		collect: [:each | each port]! !

!GLMTransmission methodsFor: 'scripting' stamp: 'tg 2/20/2010 18:21'!
passivelyFrom: aPort
	^ self addPassiveOrigin: (self browser resolveOriginPort: aPort)! !

!GLMTransmission methodsFor: 'scripting' stamp: 'DamienCassou 7/21/2011 10:48'!
passivelyFrom: aPaneSymbol port: aPortSymbol
	^ self passivelyFrom: (GLMPortIdentifier pane: aPaneSymbol port: aPortSymbol)! !

!GLMTransmission methodsFor: 'copying' stamp: 'DamienCassou 7/19/2011 17:51'!
postCopy
	origins := origins collect: [:each | each copy ].
	destination := destination copy.
	transmissionStrategy := transmissionStrategy copy.
	transmissionStrategy transmission: self! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 17:11'!
presentations
	^ self transmissionStrategy presentations! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/15/2010 02:50'!
presentations: aCompositePresentation
	self transmissionStrategy presentations: aCompositePresentation! !

!GLMTransmission methodsFor: 'transmitting' stamp: 'TudorGirba 4/18/2011 19:52'!
printOn: aStream 
	 
	aStream 
		nextPutAll: self class name;
		nextPutAll: ' (origins='; 
		nextPutAll: self origins printString; 
		nextPutAll: ' destination='; 
		nextPutAll: self destination printString; 
		nextPut: $)
	 
	! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 5/1/2011 01:57'!
to: aPort
	"Ideally this method would be implemented as
	^ self to: aPaneSymbol port: #entiity.
	
	The problem is that beforehand we only had from: which could receive either a symbol for the pane, or an association for the port. This was bad, and now Glamour offers to:port:, but there are still legacy cases of to: being called with an association."

	^ self destination: (self browser resolveDestinationPort: aPort)! !

!GLMTransmission methodsFor: 'scripting' stamp: 'tg 11/3/2010 13:36'!
to: aPaneSymbol port: aPortSymbol
	^ self to: (GLMPortIdentifier pane: aPaneSymbol port: aPortSymbol)! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 5/20/2012 00:55'!
toOutside: aPortSymbol
	self deprecated: 'Use toOutsidePort: instead'.
	^ self toOutsidePort: aPortSymbol! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 12/2/2010 20:09'!
toOutsidePort: aPortSymbol
	^ self to: #outer->aPortSymbol! !

!GLMTransmission methodsFor: 'scripting' stamp: 'TudorGirba 5/20/2012 00:51'!
toWatcher
	""
	^ self destination: (self browser watcherPane port: #entity)! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 16:25'!
transformation
	^ transformation! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 16:14'!
transformation: anObject 
	 
	transformation := anObject! !

!GLMTransmission methodsFor: 'scripting' stamp: 'tg 1/31/2010 01:52'!
transformed: aBlock
	self transformation: aBlock! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 16:43'!
transmissionStrategy
	^ transmissionStrategy! !

!GLMTransmission methodsFor: 'accessing' stamp: 'tg 1/14/2010 16:44'!
transmissionStrategy: anObject
	transmissionStrategy := anObject! !

!GLMTransmission methodsFor: 'transmitting' stamp: 'tg 1/14/2010 13:09'!
transmit
	self transmitIn: GLMTransmissionContext new! !

!GLMTransmission methodsFor: 'transmitting' stamp: 'TudorGirba 4/22/2012 23:09'!
transmitIn: aContext
	self flag: 'The transmitIt: and receive:in: both end up calling notingPresentationChangeDo:. So they should be handled by a surrounding notingPresentationChangeDo:. However, by doing that it seems that we break the morphic updating. No idea why'.
	self destination notingPresentationChangeDo: [
		self transmissionStrategy transmitIn: aContext.
		self destination receive: self in: aContext ].
	self browser notNil ifTrue: [
		self browser announce: GLMTransmissionTriggered new ]! !

!GLMTransmission methodsFor: 'transmitting' stamp: 'tg 1/31/2010 01:33'!
value
	| originalValue |
	originalValue := self originReferences size = 1 
		ifTrue: [ self originReferences first value ] 
		ifFalse: [ GLMMultiValue withAll: (self originReferences collect: [:each | each value]) ].
	^ self transformation isNil 
		ifTrue: [ originalValue ] 
		ifFalse: [ self transformation glamourValue: originalValue ]! !

!GLMTransmission methodsFor: 'scripting' stamp: 'tg 1/31/2010 01:44'!
when: aBlock
	self condition: aBlock! !

!GLMTransmission methodsFor: 'scripting' stamp: 'DamienCassou 7/20/2011 07:42'!
whenKindOf: aClass 
	 
	self when: [:each | each isKindOf: aClass]! !

Object subclass: #GLMCompositeArrangement
	instanceVariableNames: 'composite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMCompositeArrangement commentStamp: 'tg 1/6/2010 23:12' prior: 0!
This is a strategy to capture the intended arrangement of multiple presentations of a composite presentation. The subclasses define the actual arrangement.!

GLMCompositeArrangement subclass: #GLMAccordionArrangement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMAccordionArrangement methodsFor: 'rendering' stamp: 'tg 1/6/2010 23:23'!
renderGlamorouslyOn: aRenderer
	^ aRenderer renderAccordionCompositePresentation: self composite! !

!GLMCompositeArrangement classSide methodsFor: 'as yet unclassified' stamp: 'tg 1/6/2010 23:14'!
of: aCompositePresentation
	^ self new composite: aCompositePresentation; yourself! !

!GLMCompositeArrangement methodsFor: 'accessing' stamp: 'tg 1/6/2010 23:13'!
composite
	^ composite! !

!GLMCompositeArrangement methodsFor: 'accessing' stamp: 'tg 1/6/2010 23:13'!
composite: anObject
	composite := anObject! !

!GLMCompositeArrangement methodsFor: 'rendering' stamp: 'tg 1/6/2010 23:16'!
renderGlamorouslyOn: aRenderer
	self subclassResponsibility! !

GLMCompositeArrangement subclass: #GLMStackedVerticallyArrangement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMStackedVerticallyArrangement methodsFor: 'rendering' stamp: 'tg 1/7/2010 09:38'!
renderGlamorouslyOn: aRenderer
	^ aRenderer renderStackedVerticallyCompositePresentation: self composite! !

GLMCompositeArrangement subclass: #GLMTabbedArrangement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMTabbedArrangement methodsFor: 'rendering' stamp: 'tg 1/6/2010 23:23'!
renderGlamorouslyOn: aRenderer
	^ aRenderer renderTabbedCompositePresentation: self composite! !

Object subclass: #GLMPortReference
	instanceVariableNames: 'port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPortReference commentStamp: 'tg 1/5/2010 22:18' prior: 0!
A PortReference is used in Transmissions to bahavior that is specific to a Transmission instance.!

GLMPortReference subclass: #GLMOriginPortReference
	instanceVariableNames: 'active transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMOriginPortReference commentStamp: '<historical>' prior: 0!
Used by BundleTransmission to annotate its originating ports whether they are active or passive.

When a BundleTransmission consideres a port as active, the browser will trigger it when the corresponding port changes.!

!GLMOriginPortReference methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
beActive 
	 
	active := true! !

!GLMOriginPortReference methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
bePassive 
	 
	active := false! !

!GLMOriginPortReference methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isActive 
	 
	^active ifNil: [active := true]! !

!GLMOriginPortReference methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isPassive 
	 
	^self isActive not! !

!GLMOriginPortReference methodsFor: 'accessing' stamp: 'tg 1/5/2010 22:11'!
transformation
	^ transformation! !

!GLMOriginPortReference methodsFor: 'accessing' stamp: 'tg 1/5/2010 22:11'!
transformation: anObject
	transformation := anObject! !

!GLMOriginPortReference methodsFor: 'accessing-convenience' stamp: 'tg 1/5/2010 22:11'!
value
	^ self transformation isNil ifTrue: [self port value] ifFalse: [self transformation value: self port value]! !

!GLMPortReference methodsFor: 'accessing' stamp: 'tg 1/5/2010 22:06'!
port 
	 
	^port! !

!GLMPortReference methodsFor: 'accessing' stamp: 'tg 1/5/2010 22:07'!
port: aPort
	port := aPort! !

!GLMPortReference methodsFor: 'as yet unclassified' stamp: 'DamienCassou 7/19/2011 17:55'!
postCopy 
	port := port copy! !

!GLMPortReference methodsFor: 'printing' stamp: 'tg 1/13/2010 16:37'!
printOn: aStream
	super printOn: aStream.
	aStream 
		nextPut: Character space;
		nextPutAll: self identityHash printString;
		nextPutAll: ' ('.
	port printOn: aStream.
	aStream nextPut: $)! !

Object subclass: #GLMRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMRenderer commentStamp: 'tg 9/20/2009 12:43' prior: 0!
A GLMRenderer is the abstract class for the renderer hierarchy. This should be subclassed for each rendering platform (e.g. Morphic)!

!GLMRenderer methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
doOpen: aUI 
	 
	^self subclassResponsibility! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
open: aRenderable 
	 
	^self doOpen: (self render: aRenderable)! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
render: aRenderable 
	 
	^aRenderable renderGlamorouslyOn: self! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderPane: aPane 
	 
	^nil! !

!GLMRenderer methodsFor: 'rendering' stamp: 'tg 5/24/2009 19:30'!
renderPresentation: aPresentation 

	^ nil! !

Object subclass: #GLMTransmissionContext
	instanceVariableNames: 'ports forbiddenAnnouncements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMTransmissionContext commentStamp: 'DamienCassou 7/9/2011 23:44' prior: 0!
This class models the context in which a set of transmissions take place. In essence, it records all ports that were reached after an outside event. 
 
That is necessary for ensuring that transmissions do not get propagated forever. When the first transmission is triggered, a context is created and this context will then store all ports that any subsequent transmission touches. This info is used to break possible cycles

Instance Variables
	ports:		Collection of Ports!

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'TudorGirba 7/21/2011 13:43'!
addPort: aPort
	self ports add: aPort! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/19/2009 00:26'!
can: aPane announce: anAnnouncement
	^ ((self forbiddenAnnouncements at: aPane ifAbsent: [Set new])
		includes: anAnnouncement ) not! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/19/2009 00:25'!
canAnnounceMatchingPresentationsChanged: aPane
	^ self can: aPane announce: GLMMatchingPresentationsChanged! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/19/2009 00:23'!
canAnnouncePresentationsChanged: aPane
	self can: aPane announce: GLMPresentationsChanged! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/19/2009 00:21'!
forbid: aPane toAnnounce: anAnnouncement
	(self forbiddenAnnouncements at: aPane ifAbsentPut: [Set new])
		add: anAnnouncement! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/19/2009 00:22'!
forbidToAnnounceMatchingPresentationsChanged: aPane
	self forbid: aPane toAnnounce: GLMMatchingPresentationsChanged! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/19/2009 00:22'!
forbidToAnnouncePresentationsChanged: aPane
	self forbid: aPane toAnnounce: GLMPresentationsChanged! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/19/2009 00:20'!
forbiddenAnnouncements
	"forbiddenAnnouncements holds a dictionary in which the key is a pane and the value is a collection of announcements"
	^ forbiddenAnnouncements ifNil: [forbiddenAnnouncements := IdentityDictionary new]! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/19/2009 00:19'!
forbiddenAnnouncements: anObject
	forbiddenAnnouncements := anObject! !

!GLMTransmissionContext methodsFor: 'testing' stamp: 'TudorGirba 7/21/2011 13:46'!
includesPort: aPort
	^ self ports includes: aPort! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/18/2009 23:33'!
ports
	^ ports ifNil: [ports := OrderedCollection new]! !

!GLMTransmissionContext methodsFor: 'accessing' stamp: 'tg 12/18/2009 23:32'!
ports: anObject
	ports := anObject! !

!GLMTransmissionContext methodsFor: 'copying' stamp: 'TudorGirba 7/9/2011 23:54'!
postCopy
	ports := ports copy! !

!GLMTransmissionContext methodsFor: 'printing' stamp: 'TudorGirba 7/21/2011 13:39'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	ports printOn: aStream.
	aStream nextPut: $)
! !

Object subclass: #GLMTransmissionStrategy
	instanceVariableNames: 'transmission'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMTransmissionStrategy commentStamp: 'tg 2/20/2010 14:45' prior: 0!
The classes from this hierarchy define strategies for what should happen after the value have been set to the destination port.!

GLMTransmissionStrategy subclass: #GLMNoStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMNoStrategy commentStamp: 'tg 2/20/2010 14:53' prior: 0!
This is the default strategy that does nothing (an implementation of the Null pattern)!

!GLMNoStrategy methodsFor: 'transmitting' stamp: 'tg 2/20/2010 14:06'!
transmitIn: aContext
	"do nothing else then was already done by the transmission"! !

GLMTransmissionStrategy subclass: #GLMPresentStrategy
	instanceVariableNames: 'presentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentStrategy commentStamp: 'DamienCassou 7/9/2011 23:02' prior: 0!
The abstract strategy that deals with setting of presentations on the pane of the destination port.!

GLMPresentStrategy subclass: #GLMPresentIfNoneStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentIfNoneStrategy commentStamp: 'tg 2/20/2010 14:52' prior: 0!
This strategy sets presentations only if none exits in the pane of the destination port.!

!GLMPresentIfNoneStrategy methodsFor: 'transmitting' stamp: 'DamienCassou 7/9/2011 23:05'!
transmitIn: aContext
	(self transmission destination hasPane
		and: [self transmission destination pane presentations isEmpty])
	ifTrue: [	self transmission destination pane
				notingPresentationChangeDo: [
					self transmission destination pane clearIn: aContext.
					self transmission destination pane presentations: self presentations copy ] ]! !

!GLMPresentStrategy methodsFor: 'accessing-convenience' stamp: 'tg 1/14/2010 16:45'!
addPresentation: aPresentation
	self presentations add: aPresentation! !

!GLMPresentStrategy methodsFor: 'accessing-convenience' stamp: 'tg 1/14/2010 17:07'!
addPresentations: aCollection
	aCollection do: [:each | self addPresentation: each ]! !

!GLMPresentStrategy methodsFor: 'initialize-release' stamp: 'tg 1/14/2010 12:39'!
initialize
	presentations := GLMCompositePresentation new! !

!GLMPresentStrategy methodsFor: 'accessing' stamp: 'tg 1/14/2010 12:36'!
presentations
	^ presentations! !

!GLMPresentStrategy methodsFor: 'accessing' stamp: 'tg 1/14/2010 12:36'!
presentations: anObject
	presentations := anObject! !

GLMPresentStrategy subclass: #GLMReplacePresentationsStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMReplacePresentationsStrategy commentStamp: 'tg 2/20/2010 14:52' prior: 0!
This strategy replaces the presentations from the pane of the destination port.!

!GLMReplacePresentationsStrategy methodsFor: 'transmitting' stamp: 'tg 4/11/2010 23:36'!
transmitIn: aContext
	"it is important for the destination to be set after the presentation, 
	because when the presentation is a browser, we might forward the entity internally"
	self transmission destination hasPane ifTrue: [
		self transmission destination pane notingPresentationChangeDo: [
			self transmission destination pane clearIn: aContext.
			self transmission destination pane presentations: self presentations copy ]].
! !

!GLMTransmissionStrategy classSide methodsFor: 'instance creation' stamp: 'tg 1/14/2010 15:45'!
of: aTransmission
	^ self new transmission: aTransmission; yourself! !

!GLMTransmissionStrategy methodsFor: 'accessing' stamp: 'tg 1/14/2010 16:53'!
addPresentation: aPresentation
	"do nothing by default"! !

!GLMTransmissionStrategy methodsFor: 'accessing' stamp: 'tg 1/14/2010 17:07'!
addPresentations: aCollection
	"do nothing by default"! !

!GLMTransmissionStrategy methodsFor: 'accessing' stamp: 'tg 1/14/2010 17:11'!
presentations
	^ OrderedCollection new! !

!GLMTransmissionStrategy methodsFor: 'accessing' stamp: 'tg 1/14/2010 15:44'!
transmission
	^ transmission! !

!GLMTransmissionStrategy methodsFor: 'accessing' stamp: 'tg 1/14/2010 15:44'!
transmission: anObject
	transmission := anObject! !

!GLMTransmissionStrategy methodsFor: 'transmitting' stamp: 'tg 2/20/2010 14:05'!
transmitIn: aContext
	"override this method to add the desired semantics"
	self subclassResponsibility! !

Object subclass: #GLMUpdateAction
	instanceVariableNames: 'condition presentation announcement announcerObjects transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMUpdateAction commentStamp: 'TudorGirba 1/7/2011 07:30' prior: 0!
GLMUpdateAction is used for controlling the updating of a presentation when an announcement. is sent by the announcerObjects.

Instance Variables:
	condition	<Boolean>
	presentation	<GLMPresentation>
	announcement	<Announcement>
	announcerObjects	<(Collection of: Objects)>
	transformation	<BlockClosure>!

GLMUpdateAction subclass: #GLMMultipleUpdateAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMMultipleUpdateAction commentStamp: 'TudorGirba 1/7/2011 07:31' prior: 0!
This class simply specifies that the updating announcement could come from any of the objects in the announcer objects collection.!

!GLMMultipleUpdateAction methodsFor: 'public' stamp: 'tg 5/3/2010 01:18'!
computeAnnouncerObjects 
	^ self transformation glamourValue: self presentation entity! !

GLMUpdateAction subclass: #GLMSingleUpdateAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMSingleUpdateAction commentStamp: 'TudorGirba 1/7/2011 07:31' prior: 0!
This class specifies that the updating announcement should come only from the single announcer object.!

!GLMSingleUpdateAction methodsFor: 'public' stamp: 'TudorGirba 7/1/2011 23:59'!
computeAnnouncerObjects 
	self flag: 'We catch the error because if there is a problem in the computation of the announcer object, we still want to be able to continue the execution'.
	^ OrderedCollection with: 
		([self transformation glamourValue: self presentation entity] 
			on: Error 
			do: [:e | self presentation entity. e resume])! !

!GLMUpdateAction methodsFor: 'announcement handling' stamp: 'TudorGirba 2/15/2011 10:40'!
actOn: anAnnouncement
	| allowedToTrigger |
	allowedToTrigger := self condition glamourValue: (	
							anAnnouncement asGlamorousMultiValue, 
							self presentation entity asGlamorousMultiValue).
	allowedToTrigger ifTrue: [ self presentation update ]! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/2/2010 23:50'!
announcement
	^ announcement! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/2/2010 23:50'!
announcement: anObject
	announcement := anObject! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/3/2010 00:19'!
announcerObjects 
	^ announcerObjects := self computeAnnouncerObjects ifNil: [OrderedCollection new]! !

!GLMUpdateAction methodsFor: 'public' stamp: 'tg 5/3/2010 00:12'!
computeAnnouncerObjects 
	self subclassResponsibility! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/2/2010 23:46'!
condition
	^ condition! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/2/2010 23:46'!
condition: anObject
	condition := anObject! !

!GLMUpdateAction methodsFor: 'initialize-release' stamp: 'tg 5/24/2010 17:19'!
initialize
	super initialize.
	condition := true! !

!GLMUpdateAction methodsFor: 'copying' stamp: 'tg 5/3/2010 01:19'!
postCopy
	super postCopy.
	announcerObjects := nil! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/2/2010 23:46'!
presentation
	^ presentation! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/2/2010 23:46'!
presentation: anObject
	presentation := anObject! !

!GLMUpdateAction methodsFor: 'public' stamp: 'EstebanLorenzano 6/16/2011 15:23'!
registerInPresentation
	self announcerObjects do: [: announcerObject |
		announcerObject notNil ifTrue: [
			(announcerObject on: self announcement send: #actOn: to: self) makeWeak.
			
			"we remember the announcer object to be able to 
			unregister from it when the presentation goes away"
			self presentation registeredAnnouncers add: announcerObject ] ]! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/3/2010 01:18'!
transformation
	^ transformation! !

!GLMUpdateAction methodsFor: 'accessing' stamp: 'tg 5/3/2010 01:18'!
transformation: anObject
	transformation := anObject! !

!GLMUpdateAction methodsFor: 'public' stamp: 'HenrikSperreJohansen 3/12/2011 11:59'!
unregisterFromAllAnnouncements
	self announcerObjects do: [:each | 
		[each unsubscribe: self] on: Error do: [:e | e resume]] ! !
GLMLoggedObject initialize!
GLMNoBrowser initialize!
